#include <mem.h>

#include <stdio.h>



const MAXN = 10;



struct State {

	int T[MAXN],side;

};



struct GNode {

	int nc,neighbors[MAXN];

};



FILE *out;

int states[2048],scount,From[2048];

GNode G[MAXN];

int n,m;



int FromStateToInt(State &S){

	int ret = 0;

	for (int i = n-1; i >= 0; i--) ret = ret*2+S.T[i];

	return ret*2+S.side;

}



void FromIntToState(int k,State &S){

	S.side = k%2; k /= 2;

	for (int i = 0; i < n; i++){

		S.T[i] = k%2; k /= 2;

	}

}



void TryNext(int cur,State &S,int *Count,int MCandid){

	if (cur >= n){

		if (MCandid > m) m = MCandid;

		S.side = 0;

		states[scount++] = FromStateToInt(S);

		S.side = 1;

		states[scount++] = FromStateToInt(S);

		return;

	}

	S.T[cur] = 0;

	TryNext(cur+1,S,Count,MCandid);

	if (!Count[cur]){

		for (int i = 0; i < G[cur].nc; Count[G[cur].neighbors[i++]]++);

		S.T[cur] = 1;

		TryNext(cur+1,S,Count,MCandid+1);

		for (i = 0; i < G[cur].nc; Count[G[cur].neighbors[i++]]--);

	}

}



void GetStates(){

	State S;

	int Count[MAXN];

	for (int i = 0; i < MAXN; Count[i++] = 0);

	scount = 0;

	m = -1;

	TryNext(0,S,Count,0);

}



void GetGraph(){

	FILE *in = fopen("upe.dat","rt");

	int ec;

	fscanf(in,"%d %d",&n,&ec);

	for (int i = 0; i < n; i++) G[i].nc = 0;

	for (i = 0; i < ec; i++){

		int a,b;

		fscanf(in,"%d %d",&a,&b);

		if (a > b) { int temp = a; a = b; b = temp; }

		G[a-1].neighbors[G[a-1].nc++] = b-1;

	}

	fclose(in);

}



int CalcMinMoves(int maxplaces){

	int Dist[2048], Q[2048], first, last;

	State S,S1;

	for (int i = 0; i < 2048; Dist[i++] = -1);

	Dist[0] = 0; From[0] = -1;

	Q[0] = 0; first = last = 0;

	while (first <= last){

		int cur = Q[first++];

		FromIntToState(cur,S);

		int start = (S.side) ? 0 : 1;

		for (i = start; i < scount; i += 2){

			int cur1 = states[i];

			FromIntToState(cur1,S1);

			if (Dist[cur1] == -1){

				int count = 0;

				for (int j = 0; j < n; j++)

					if (S1.T[j]){

						if (S.T[j]) { count = 30000; break; }

					}

					else if (!S.T[j]) count++;

				if (count <= maxplaces){

					Dist[cur1] = Dist[cur]+1; From[cur1] = cur;

					if (cur1 == 1) return Dist[cur1];

					Q[++last] = cur1;

				}

			}

		}

	}

	return -1;

}



void PrintSolution(int minmoves,int minplaces){

	int tempstates[2048];

	int tscount = 0;

	for (int i = 1; i != -1; i = From[i]) tempstates[tscount++] = i;



	FILE *out = fopen("upe.rez","wt");

	fprintf(out,"%d %d\n",minplaces,minmoves);

	State S,S1;

	FromIntToState(tempstates[tscount-1],S);

	int curmove = 1;

	for (i = tscount-2; i >= 0; i--){

		fprintf(out,"%d: ",curmove++);

		FromIntToState(tempstates[i],S1);

		for (int j = 0; j < n; j++)

			if (!S.T[j] && !S1.T[j]) fprintf(out,"%d ",j+1);

		fprintf(out,"\n");

		S = S1;

	}

	fclose(out);

}



void main(){

	GetGraph();

	GetStates();

	// We have all states and the capacity  m of the largest independent set

	int t = CalcMinMoves(n-m);

	if (t != -1) PrintSolution(t,n-m);

	else PrintSolution(CalcMinMoves(n-m+1),n-m+1);

}