/* Udavinio autorius: Dr. Mindaugas Plukas, VU MIF dstytojas;
   Sprendim bei testus pareng: Dr. Mindaugas Plukas */ 


#include <stdlib.h>
#include <stdio.h>


#define MAX_KAMBARIU 80

short perejimai[MAX_KAMBARIU][MAX_KAMBARIU] ; 
/* perjimai[I][J] = 1 <=> yra perjimas i kambario I  J 
   perjimai[I][J] = 0 <=> nera perjimo i kambario I  J */
   
int taskai[MAX_KAMBARIU] ;
/* takai[I] - takai (prizas arba bauda ) kambaryje I */

int isrKamb[MAX_KAMBARIU] ;
/* isrKamb - topologikai iriuot kambari numeri masyvas; t.y
   k < l => nra kelio i kambario isrKamb[l]  kambar isrKamb[k] */    

int maxTasku[MAX_KAMBARIU] ;
/* maxTasku[I] - kiek maksimaliai tak galima gauti, baigiant kelion iame kambaryje
   (o pradedant bet kuriame kambaryje) */

int N = 0 ; /* Kambari skaiius */


/* Topologikai rikiuoja labirint */
void topolRusiuok( void ) ;

void main()
{
   FILE *fpDuom = NULL ;
   FILE *fpRez = NULL ;
   
   int i = 0, j = 0, k = 0 ; 
   int maxTaskuLabirinte = 0 ; 
   
   /* Nuskaitom duomenis */
   fpDuom = fopen( "LABIRINT.DAT", "r" ) ;
   fscanf( fpDuom, " %d ", &N ) ;
   
   for ( i = 0 ; i < N ; i ++ )
    for ( j = 0 ; j < N ; j ++ )
      perejimai[i][j] = 0 ;
     
   for ( i = 0 ; i < N ; i ++ )
    {
      int P = 0 ;
      fscanf( fpDuom, " %d ", &taskai[i] ) ;
      fscanf( fpDuom, " %d ", &P ) ;
      for ( k = 0 ; k < P ; k ++ )
       {
         fscanf( fpDuom, " %d ", &j ) ;
         perejimai[i][j-1] = 1 ;
       }  
    }
    
   fclose( fpDuom ) ;

   /* Topologikai irikiuojam kambarius */
   topolRusiuok() ;

   /* Kambarius apdorojame topologinio rikiavimo tvarka(praddami nuo kambario(-iu) 
       kuriuos nra einani perjim);
      kiekvienam kambariui surandam kiek max tak galima surinkti, baigiant kelion
      jame( o pradedant viename i topologikai pirmesni kambari) */
   for ( k = 0 ; k < N ; k ++ )
    {
       i = isrKamb[k] ;
       maxTasku[i] = taskai[i] ;
       for ( j = 0 ; j < N ; j ++ )
        if ( perejimai[j][i] ) /* i kambario j yra perjimas  kambar i */
         {
           if ( maxTasku[j] + taskai[i] > maxTasku[i] )
             maxTasku[i] = maxTasku[j] + taskai[i] ; 
         }
    }

   /* Surandam, kiek maksimaliai tak galima surinkti labirinte */
   maxTaskuLabirinte = maxTasku[0] ; 
   for ( i = 1 ; i < N ; i ++ )
    {
      if ( maxTaskuLabirinte < maxTasku[i] )
        maxTaskuLabirinte = maxTasku[i] ;
    }

   /* Ivedam rezultatus */ 
   fpRez = fopen( "LABIRINT.REZ", "w" ) ;
   fprintf( fpRez, "%d\n", maxTaskuLabirinte ) ;
   fclose( fpRez ) ;

}



/* Topologinis labirinto rikiavimas */


/* Kambariu stekas */
int kambariuStekas[MAX_KAMBARIU] ;
int stekoVirsus = 0 ;

void ST_istustink( void )
{
  stekoVirsus = 0 ;
}

short ST_tuscias( void )
{
  if ( stekoVirsus == 0 )
    return 1 ;
  else  
    return 0 ;
}

void ST_dek( int i )
{
  kambariuStekas[stekoVirsus] = i ;
  stekoVirsus ++ ;
}

int ST_imk( void )
{
  stekoVirsus -- ;
  return kambariuStekas[stekoVirsus] ;
}
/* Kambari steko apibrimo pabaiga */


int ieinanciuPerejimu[MAX_KAMBARIU] ;
/* einaniPerjim[I] - kiek perjim eina  kambar I */

void topolRusiuok( void )
{
   int i = 0, j = 0 ;
   int num = 0 ;
   
   /* Suskaiiuojam kiek perjim eina  kiekvien kambar */
   for ( i = 0 ; i < N ; i ++ )
    {
      ieinanciuPerejimu[i] = 0 ;
      for ( j = 0 ; j < N ; j ++ )
       if ( perejimai[j][i] )
         ieinanciuPerejimu[i] ++ ;
    }

   /* Sudedam  stek visus kambarius,  kuriuos nra perjim
      ( privalo bti bent vienas toks kambarys ) */
   ST_istustink() ;
   for ( i = 0 ; i < N ; i ++ )
    if ( ieinanciuPerejimu[i] == 0 )
      ST_dek( i ) ;
     
   /* Numeruojam praddami nuo kambari  kuriuos nra perjim ir 
      sunumeruotus kambarius "alinam" i labirinto */
   num = 0 ;  
   while ( ! ST_tuscias() )
    {
      i = ST_imk() ;
      isrKamb[num] = i ;
      num ++ ;

      for ( j = 0 ; j < N ; j ++ )
       if ( perejimai[i][j] )
        {
          ieinanciuPerejimu[j] -- ;
          if ( ieinanciuPerejimu[j] == 0 )
            ST_dek( j ) ;
        }  
    }  
}


