/* Udavinio autorius: Tomas Laurinaviius, VU MIF studentas;
   Sprendim bei testus pareng: Dr. Mindaugas Plukas, VU MIF dstytojas */  

#include <stdlib.h>
#include <stdio.h>


/*  
   Udavinys susiveda  maksimalaus suporavimo dvidaliame grafe radim.
   Lentos vienetiniai langeliai atitinka grafo virnes,o jos sujungtos briaunomis 
   su kaimynais i viraus, deins, kairs ir apaios. Tada bet koks supjaustymas
    dviej vienetini kvadratli dydio staiakampius atitinka suporavim grafe, ir
   atvirkiai - suporavimas gafe atitinka supjaustym. Lent atitinkantis grafas
   yra dvidalis: virns, kurias atitinkani langeli koordinai suma yra lygin,
   sudaro viena dal( vadinsime j "lygin"), likusios - kit( vadinsime j "nelygin").
   
   Maksimalaus suporavimo dvidaliame grafe radimui ia naudojame adaptuot dvidaliam grafui bazin 
   Fordo-Fulkersono algoritm. Turimam suporavimui bandome iekoti didinanios(alternuojanios)
   grandins - grandins, kuri prasidt ir baigtusi nesuporuota virne, o joje kaitaliotusi briaunos,
   priklausanios ir nepriklausanios turimam suporavimui. Toks kelias yra nelyginio ilgio, jo vienas
   galas yra "lygin" virn, kitas - "nelygin". Didinanios grandins iekosime praddami nuo 
   nesuporuot lygini virni vykdydami paiek platyn. Jei grandin radome, tai j pritaikome - 
   grandins briaunas, kurios priklauso suporavimui, i suporavimo imetame, o grandins briaunas,
   nepriklausanias suporavimui prijungiame prie jo; tokiu bdu gausime nauj suporavim, kuris turs
   viena briauna daugiau. Jei didinanios grandins turimam suporavimui neegzistuoja, tai jis yra 
   maksimalus ir darb baigiame.
    
   Tokio algoritmo darbo laikas yra O( (N*M)^2 ). 
 */


#define MAX_LENTOS_DYDIS 50
 
typedef struct _TLangelis 
{
   int fYra ; /* =0, jei langelis ipjautas, 
                 =1, jei langelis yra 
               */
                   
   int porI, porJ ; /* >ie laukai naudojami siminti turim suporavim.
                         Jei virn suporuota, tai laukuose saugomos virns porininks koordinates,
                         jei virn nesuporuota, tai jie lygus (-1) 
                       */
                         
   int isI, isJ;  /* ie laukai naudojami, iekant didinanios grandins, paiekai  plot realizuoti.
                     Jei i virn aplankyta, tai:
                        jei ji pradin paiekos virn, tai laukai lygs (-2)
                        jei ji nepradin paiekos virn, tai laukai lygus koordinatms
                          virns i kurios  j atjom.
                     Jei i virn nepalankyta, tai laukai lygs (-2). 
                   */        

} TLangelis ;

typedef TLangelis TLenta[MAX_LENTOS_DYDIS][MAX_LENTOS_DYDIS] ;

int N  = 0 ;   /* Lentos plotis */
int M  = 0 ;   /* Lentos ilgis  */
TLenta lenta ; /* Lenta         */

/* Turimo suporavimo briaun skaiius */
int supDydis = 0 ;


/* 
   Bando rasti didinani grandin ir j pritaiko
   Jei didinanti grandin rasta, tai graina 1, ir graina 0 prieingu atveju.
 */
int padidink( void ) ;


void main()
{
   FILE *fpDuom = NULL ;
   FILE *fpRez = NULL ;
   int i = 0, j = 0 ;
   int kiekIspj = 0 ;
   int fRadomPadidinima = 0 ; 

/* Nuskaitom plot, ilg */
   fpDuom = fopen( "LENTA.DAT", "r" ) ;
   fscanf( fpDuom, " %d ", &N ) ;
   fscanf( fpDuom, " %d ", &M ) ;
   
/* Inicializuojam nesupjaustyt lent */
   for ( i = 0 ; i < N ; i ++ )
    for ( j = 0 ; j < M ; j ++ )
     {
       lenta[i][j].fYra = 1 ; 
     }
    
/* Nuskaitom ipjautus langelius */
   fscanf( fpDuom, " %d ", &kiekIspj ) ;
   while ( kiekIspj > 0 )
    {
      int ispjI = 0, ispjJ = 0 ;
      fscanf( fpDuom, " %d %d ", &ispjI, &ispjJ ) ;
      lenta[ispjI-1][ispjJ-1].fYra = 0 ;
      kiekIspj -- ;
    }
   fclose( fpDuom ) ; 
    

/* Turim tui suporavim */
   supDydis = 0 ;
   for ( i = 0 ; i < N ; i ++ )
    for ( j = 0 ; j < M ; j ++ )
     {
       lenta[i][j].porI = -1 ; 
       lenta[i][j].porJ = -1 ; 
     }

/* Randam maksimal suporavim, iekodami ir pritaikydami didinanias grandines */
   do {
   
     fRadomPadidinima = padidink() ;
   
    } while ( fRadomPadidinima ) ;


/* Ivedam maksimalaus suporavimo briaun skaii */
   fpRez = fopen( "LENTA.REZ", "w" ) ;
   fprintf( fpRez, "%d\n", supDydis ) ;
   fclose( fpRez ) ;

}


/* Virni eil  */
struct _VirsuniuEilesElementas 
{ 
   int i,j ; 
} virsuniuEile[ MAX_LENTOS_DYDIS * MAX_LENTOS_DYDIS ] ;

int eilPradzia = 0, eilGalas = 0 ;

void VE_istustink( void )
{
   eilPradzia = 0 ;
   eilGalas = 0 ;
}

int VE_tuscia( void )
{
   return eilPradzia >= eilGalas ;
}

void VE_dek( int i, int j )
{
   virsuniuEile[eilGalas].i = i ;
   virsuniuEile[eilGalas].j = j ;
   eilGalas ++ ;
}

void VE_imk( int *pI, int *pJ )
{
   *pI = virsuniuEile[eilPradzia].i ;
   *pJ = virsuniuEile[eilPradzia].j ;
   eilPradzia ++ ;
}
/* Virni eils apibrimo pabaiga */


int padidink( void )
{
   int fRadom = 0 ; /* Ar radom didinani grandin */
   int iR = 0, jR = 0 ; /* Didinanios grandins paskutin virn */
   int i = 0, j = 0 ;

   /* Ivalom paiekos laukus */
   for ( i = 0 ; i < N ; i ++ )
    for ( j = 0 ; j < M ; j ++ )
     {
       lenta[i][j].isI = -1 ;
       lenta[i][j].isJ = -1 ;
     }

   /* Eilje saugosime visas aplankytas virnes nuo kuri reikia bandyti daryti ingsn.
      Paiek pradedam nuo nesuporuot "lygini" virni; Jas sudedam  eil.  
    */ 
   VE_istustink() ;
   for ( i = 0 ; i < N ; i ++ )
    for ( j = 0 ; j < M ; j ++ )
     {
       if ( (i+j) % 2 == 0 && lenta[i][j].fYra ) /* Pradedam nuo "lygins" dalies neporuot virni */
        {
          if ( lenta[i][j].porI == -1  ) /* Neporuota virsune */
           {
              VE_dek( i, j ) ;
              lenta[i][j].isI = -2 ;/* Pradins paiekos virns */  
              lenta[i][j].isJ = -2 ; 
           }
        }
     }
     
   fRadom = 0 ;
   while ( !VE_tuscia() && !fRadom )
    {
      int i = 0, j = 0 ; /* I kur darom ingsn */
      int ii = 0, jj = 0 ; /*  kur darom ingsn */
      int fLyginis = 0  ;  /* Ar nagrinjama virn "lygin" */
      
      VE_imk( &i, &j ) ;
      fLyginis = ( i + j ) % 2 == 0 ;
      
      if ( ! fLyginis )
       {
         /* Virn "nelygin". Ji btinai bus suporuota ir i jos einame suporavimo briauna 
          */
         ii = lenta[i][j].porI ;
         jj = lenta[i][j].porJ ;
         
         lenta[ii][jj].isI = i ; /* simenam, i kur atjom */
         lenta[ii][jj].isJ = j ;
         VE_dek( ii, jj ) ;
         /*  eil idjom "lygin" virn. Ji yra suporuota, o jos porinink jau aplankyta */
        }
       else
        { /* Virn "lygin". I jos bandome eiti visomis
             suporavimui nepriklausaniomis briaunomis    
             Nagrinjama aplankyta "lygin" virn bus arba nesuporuota( pradin ),
             arba suporuota ir  j esame atj i jos porininks. Todl
             galime tiesiog eiti  visas neaplamkytas virnes.
           */
         
          int k = 0 ;
          for ( k = 1 ; k <= 4 ; k ++ )
           {
             /* Bandom eiti  kaimynin virn */
             switch ( k )
              {
                 case 1 :
                   ii = i ;
                   jj = j + 1 ;
                  break ;
                 case 2 :
                   ii = i + 1 ;
                   jj = j ;
                  break ;
                 case 3 :
                   ii = i ;
                   jj = j - 1 ;
                  break ;
                 case 4 :
                   ii = i - 1 ;
                   jj = j ;
                  break ;
              } ;
              
             /* Patikrinam, ar ingsnis galimas */ 
             if ( ii < 0 || ii >= N || jj < 0 || jj >= M || 
                  ! lenta[ii][jj].fYra ||
                  lenta[ii][jj].isI != -1 /*Jau buvom*/
                )
               continue ;
               
             lenta[ii][jj].isI = i ; /* simenam, i kur atjom */
             lenta[ii][jj].isJ = j ;
             
             if ( lenta[ii][jj].porI == -1  ) 
              /* Prijom "nelygin" neporuot virn; reikia radom didinani grandin
                 ir paiekas nutraukiam.
               */
              {
                fRadom = 1 ;
                iR = ii ; jR = jj ;
                break ;
              } 
             else
              {
                VE_dek( ii, jj ) ;
                /*  eil idjom "nelygin" virn. Ji btinai bus suporuota */
              } 
           }   
        }
     }
      
   if ( fRadom )
    {
      int i = 0, j = 0 ; /* I kur darom ingsn */
      int ii = 0, jj = 0 ; /*  kur darom ingsn */
      int fPoruoti = 0 ;   /* Ar nagrinjama grandins briauna traukti  suporavim */

      /* Einam didinania grandine ir keiiam briaun suporavim */
      i = iR ;
      j = jR ;
      fPoruoti = 1 ;
      
      do {
        ii = lenta[i][j].isI ;
        jj = lenta[i][j].isJ ;
        
        if ( fPoruoti )
         {
           lenta[i][j].porI = ii ;
           lenta[i][j].porJ = jj ;
           lenta[ii][jj].porI = i ;
           lenta[ii][jj].porJ = j ;
         }
        
        i = ii ;
        j = jj ;
        fPoruoti = ! fPoruoti ;
      
      } while ( lenta[i][j].isI != -2 ) ;
      
      /* Suporavimas padidjo viena briauna */
      supDydis ++ ; 
    }
   
   return fRadom ;
}

