/*
  @author Emilian Miron, Universitatea Bucuresti

  T = O(N), M = O(N)
*/

#include <cstdio>


#define maxk 128
#define maxn (128*1024)

#define prime (10007)

int adj[maxn][2], N, K, R;



void init()
{
   int i;
   scanf ("%d%d%d", &N, &R, &K);
   for (i = 1; i <= N; i++)
      scanf ("%d%d", &adj[i][0], &adj[i][1]);
}


int c[maxn][4][4][4];

int solve (int n, int cfirst, int ccurrent, int clast)
{
   int i, j, n1, n2;

   if (c[n][cfirst][ccurrent][clast] > 0)
      return c[n][cfirst][ccurrent][clast] - 1;

   if (adj[n][0] == 0) {
      n1 = cfirst == ccurrent ? 1 : 0;
   } else {
      int lt = adj[n][0];
      if (ccurrent == cfirst) {
         n1 =  solve(lt, 1, 2, 2) * (K - 1) % prime;
         n1 += solve(lt, 1, 2, 3) * (K - 1) % prime * (K - 2) % prime;
         n1 %= prime;
      } else {
         n1 =  solve(lt, 1, 1, 1);
         n1 += solve(lt, 1, 1, 2) * (K - 2) % prime;
         n1 += solve(lt, 1, 2, 1) * (K - 2) % prime;
         n1 += solve(lt, 1, 2, 2) * (K - 2) % prime;
         n1 += solve(lt, 1, 2, 3) * (K - 2) % prime * (K - 3) % prime;
         n1 %= prime;
      }
   }

   if (adj[n][1] == 0) {
      n2 = clast == ccurrent ? 1 : 0;
   } else {
      int rt = adj[n][1];
      if (ccurrent == clast) {
         n2 =  solve(rt, 1, 1, 2) * (K - 1) % prime;
         n2 += solve(rt, 1, 2, 3) * (K - 1) % prime * (K - 2) % prime;
         n2 %= prime;
      } else {
         n2 =  solve(rt, 1, 1, 1);
         n2 += solve(rt, 1, 2, 2) * (K - 2) % prime;
         n2 += solve(rt, 1, 2, 1) * (K - 2) % prime;
         n2 += solve(rt, 1, 1, 2) * (K - 2) % prime;
         n2 += solve(rt, 1, 2, 3) * (K - 2) % prime * (K - 3) % prime;
         n2 %= prime;
      }

   }


   c[n][cfirst][ccurrent][clast] = n1 * n2 % prime + 1;
//   printf ("c(%d : %d%d%d) = %d\n", n, cfirst, ccurrent, clast,
//           c[n][cfirst][ccurrent][clast] - 1);
   return c[n][cfirst][ccurrent][clast] - 1;
}


int main()
{
   int i, j, k, sol = 0;

   freopen ("acolor.in", "rt", stdin);
   freopen ("acolor.out", "wt", stdout);

   init ();

   sol =  solve (R, 1, 1, 1) * K % prime;
   sol += solve (R, 1, 1, 2) * K % prime * (K - 1) % prime;
   sol += solve (R, 1, 2, 1) * K % prime * (K - 1) % prime;
   sol += solve (R, 1, 2, 2) * K % prime * (K - 1) % prime;
   sol += solve (R, 1, 2, 3) * K % prime * (K - 1) % prime * (K - 2) % prime;
   sol %= prime;


   printf ("%d\n", sol);


   return 0;
}

