#include <fstream.h>
#define Fin  "cub.in"
#define Fout "cub.ok"
#define Nmax 51
#define infinit 20000
typedef int matrix[7][Nmax][Nmax];
typedef int vector[7*Nmax*Nmax];
matrix Cub;	//retine cele 6 fetze ale cubului
matrix Lg;	//Lg[f][i][j] = lungimea minima a drumului de la pozitia
		    //             initiala la pozitia (f,i,j)
int N;		//latura cubului
int K;		//numarul trapelor de acces
int Fi, Li, Ci; //coordonatele pozitiei initiale
vector F,L,C;	//retin coordonatele trapelor
//prototipurile functiilor utilizate
void read_data();
void init();
void urm(int &, int &, int &, char);
void rez();
void afis(int);
void write_data();


int main()
 {
  read_data();
  init();
  rez();
  write_data();
  return 0;
 }

//definirea functiilor
void read_data()
 {
  int i,j,k;
  ifstream f(Fin);
  f>>N>>K;
  f>>Fi>>Li>>Ci;
  for(i=1;i<=K;i++) f>>F[i]>>L[i]>>C[i];
  for(k=1;k<=6;k++)
   for(i=1;i<=N;i++)
     for(j=1;j<=N;j++) f>>Cub[k][i][j];
  f.close();
 }

void write_data()
 {
  int i, nrt, min=infinit,j;
  ofstream g(Fout);
  nrt=0;
  for(i=1;i<=K;i++)
   if(Lg[ F[i] ][ L[i] ][ C[i] ]!=infinit)
     if(min>Lg[ F[i] ][ L[i] ][ C[i] ]) min=Lg[ F[i] ][ L[i] ][ C[i] ],nrt=1;
     else if(min==Lg[ F[i] ][ L[i] ][ C[i] ]) nrt++;
  if(min==infinit) g<<"Eroare !";
  {
   g<<min<<'\n';
   g<<nrt<<'\n';
  }
  g.close();
 }

void init()
 {
  int i,j,k;
  for(k=1;k<=6;k++)
   for(i=1;i<=N;i++)
     for(j=1;j<=N;j++) Lg[k][i][j]=infinit;
 }

void urm(int &f, int &l, int &c, char dir)
 {
  if(f==1){
     if(dir=='N') if(l==1) f=4,l=1,c=N-c+1; else l=l-1; else
     if(dir=='E') if(c==N) f=5,c=N-l+1,l=1; else c=c+1; else
     if(dir=='S') if(l==N) f=2,l=1;	        else l=l+1; else
     if(dir=='V') if(c==1) f=6,c=l,l=1;	    else c=c-1;
  } else
  if(f==2){
     if(dir=='N') if(l==1) f=1,l=N;         else l=l-1; else
     if(dir=='E') if(c==N) f=5,c=1;         else c=c+1; else
     if(dir=='S') if(l==N) f=3,c=N-c+1;     else l=l+1; else
     if(dir=='V') if(c==1) f=6,c=N; 	    else c=c-1;
  } else
  if(f==3){
     if(dir=='N') if(l==1) f=4,l=N;         else l=l-1; else
     if(dir=='V') if(c==1) f=5,c=N-l+1,l=N; else c=c-1; else
     if(dir=='S') if(l==N) f=2,c=N-c+1,l=N; else l=l+1; else
     if(dir=='E') if(c==N) f=6,c=l,l=N; else c=c+1;
  } else
  if(f==4){
     if(dir=='N') if(l==1) f=1,c=N-c+1,l=1; else l=l-1; else
     if(dir=='V') if(c==1) f=5,c=N;         else c=c-1; else
     if(dir=='S') if(l==N) f=3,l=1;         else l=l+1; else
     if(dir=='E') if(c==N) f=6,c=1;         else c=c+1;
  } else
  if(f==5){
     if(dir=='N') if(l==1) f=1,l=N-c+1,c=N; else l=l-1; else
     if(dir=='E') if(c==N) f=4,c=1;         else c=c+1; else
     if(dir=='S') if(l==N) f=3,l=N-c+1,c=1; else l=l+1; else
     if(dir=='V') if(c==1) f=2,c=N;         else c=c-1;
  } else
  if(f==6){
     if(dir=='N') if(l==1) f=1,l=c,c=1;     else l=l-1; else
     if(dir=='E') if(c==N) f=2,c=1;             else c=c+1; else
     if(dir=='S') if(l==N) f=3,l=c,c=N;     else l=l+1; else
     if(dir=='V') if(c==1) f=4,c=N;             else c=c-1;
  }
}

void rez()
 {
  vector cf,cl,cc;
  int p,u;
  int x,y,z;
  p=1;u=1;
  cf[u]=Fi; cl[u]=Li; cc[u]=Ci;Lg[Fi][Li][Ci] = 1;
  while(p<=u)
   {
    x=cf[p];y=cl[p];z=cc[p];urm(x,y,z,'N');
    if(Lg[x][y][z]==infinit && Cub[x][y][z]==0)Lg[x][y][z]=Lg[cf[p]][cl[p]][cc[p]]+1,cf[++u]=x,cl[u]=y,cc[u]=z;
    x=cf[p];y=cl[p];z=cc[p];urm(x,y,z,'E');
    if(Lg[x][y][z]==infinit && Cub[x][y][z]==0) Lg[x][y][z]=Lg[cf[p]][cl[p]][cc[p]]+1,cf[++u]=x,cl[u]=y,cc[u]=z;
    x=cf[p];y=cl[p];z=cc[p];urm(x,y,z,'S');
    if(Lg[x][y][z]==infinit && Cub[x][y][z]==0) Lg[x][y][z]=Lg[cf[p]][cl[p]][cc[p]]+1,cf[++u]=x,cl[u]=y,cc[u]=z;
    x=cf[p];y=cl[p];z=cc[p];urm(x,y,z,'V');
    if(Lg[x][y][z]==infinit && Cub[x][y][z]==0) Lg[x][y][z]=Lg[cf[p]][cl[p]][cc[p]]+1,cf[++u]=x,cl[u]=y,cc[u]=z;
    p++;
   }
 }
