program cub;

const NMAX = 50;
      FMAX = 6;
      INF = 16000;
      NMUT = 4;
      dl: array[1..NMUT] of integer = (-1, 0, +1, 0);
      dc: array[1..NMUT] of integer = (0, +1, 0, -1);
      rot: array[1..FMAX, 1..NMUT] of byte =
      (
      (4,5,2,6),
      (1,5,3,6),
      (4,6,2,5),
      (1,6,3,5),
      (1,4,3,2),
      (1,2,3,4)
      );

type intarray = array[1..FMAX, 1..NMAX, 1..NMAX] of integer;
     pintarray = ^intarray;
     bytearray = array[1..FMAX, 1..NMAX, 1..NMAX] of integer;
     pbytearray = ^intarray;
     queuearray = array[1..FMAX*NMAX*NMAX] of byte;
     pqueuearray = ^queuearray;

var c, nv, trapa: pbytearray;
    fv, lv, cv: array[1..NMUT] of pbytearray;
    di: pintarray;
    qf, ql, qc: pqueuearray;
    f, i, j, fne, ine, jne, k, N, fl, il, jl, li, ls, dmin, count: integer;

begin
new(c);
new(nv);
new(di);
new(trapa);

for k := 1 to NMUT do
  begin
    new(fv[k]);
    new(lv[k]);
    new(cv[k]);
  end;

assign(input, '6-cub.in');
reset(input);
read(N, k);

{ initializare }
for f := 1 to FMAX do
  for i := 1 to N do
    for j := 1 to N do
      begin
        nv^[f, i, j] := 0;
        trapa^[f, i, j] := 0;
        di^[f, i, j] := INF;
      end;

{ citirepozitie initiala }
read(fl, il, jl);

{ citire pozitii trape de acces }
while (k > 0) do
  begin
    read(f, i, j);
    trapa^[f, i, j] := 1;
    k := k - 1;
  end;

{ citire fetele cubului }
for f := 1 to FMAX do
  for i := 1 to N do
    for j := 1 to N do
      read(c^[f, i, j]);

close(input);

{ construieste "graful" cubului }
for f := 1 to FMAX do
  for i := 1 to N do
    for j := 1 to N do
      for k := 1 to NMUT do
        begin
          ine := i + dl[k];
          jne := j + dc[k];

          if (ine >= 1) and (ine <= N) and (jne >= 1) and (jne <= N) then
            begin
              { aceeasi fata }
              fne := f;
            end
          else
            begin
              { nashpa treaba :( }
              fne := rot[f, k];

              if (ine < 1) then { 1 }
                begin
                  if (f = 1) then
                    begin
                      ine := 1;
                      jne := N - j + 1;
                    end
                  else
                  if (f = 2) then
                    begin
                      ine := N;
                      jne := j;
                    end
                  else
                  if (f = 3) then
                    begin
                      ine := N;
                      jne := j;
                    end
                  else
                  if (f = 4) then
                    begin
                      ine := 1;
                      jne := N - j + 1;
                    end
                  else
                  if (f = 5) then
                    begin
                      ine := N - j + 1;
                      jne := N;
                    end
                  else
                  if (f = 6) then
                    begin
                      ine := j;
                      jne := 1;
                    end;
                end
              else
              if (ine > N) then { 3 }
                begin
                  if (f = 1) then
                    begin
                      ine := 1;
                      jne := j;
                    end
                  else
                  if (f = 2) then
                    begin
                      ine := N;
                      jne := N - j + 1;
                    end
                  else
                  if (f = 3) then
                    begin
                      ine := N;
                      jne := N - j + 1;
                    end
                  else
                  if (f = 4) then
                    begin
                      ine := 1;
                      jne := j;
                    end
                  else
                  if (f = 5) then
                    begin
                      ine := N - j + 1;
                      jne := 1;
                    end
                  else
                  if (f = 6) then
                    begin
                      ine := j;
                      jne := N;
                    end;
                end
              else
              if (jne < 1) then { 4 }
                begin
                  if (f = 1) then
                    begin
                      ine := 1;
                      jne := i;
                    end
                  else
                  if (f = 2) then
                    begin
                      ine := i;
                      jne := N;
                    end
                  else
                  if (f = 3) then
                    begin
                      ine := N;
                      jne := N - i + 1;
                    end
                  else
                  if (f = 4) then
                    begin
                      ine := i;
                      jne := N;
                    end
                  else
                  if (f = 5) then
                    begin
                      ine := i;
                      jne := N;
                    end
                  else
                  if (f = 6) then
                    begin
                      ine := i;
                      jne := N;
                    end;
                end
              else
              if (jne > N) then { 2 }
                begin
                  if (f = 1) then
                    begin
                      ine := 1;
                      jne := N - i + 1;
                    end
                  else
                  if (f = 2) then
                    begin
                      ine := i;
                      jne := 1;
                    end
                  else
                  if (f = 3) then
                    begin
                      ine := N;
                      jne := i;
                    end
                  else
                  if (f = 4) then
                    begin
                      ine := i;
                      jne := 1;
                    end
                  else
                  if (f = 5) then
                    begin
                      ine := i;
                      jne := 1;
                    end
                  else
                  if (f = 6) then
                    begin
                      ine := i;
                      jne := 1;
                    end;
                end;
            end;

          inc(nv^[f, i, j]);
          fv[nv^[f, i, j]]^[f, i, j] := fne;
          lv[nv^[f, i, j]]^[f, i, j] := ine;
          cv[nv^[f, i, j]]^[f, i, j] := jne;
        end;

{ initializare Lee }

di^[fl, il, jl] := 1;
li := 1;
ls := 1;

new(qf);
qf^[1] :=fl;
new(ql);
ql^[1] := il;
new(qc);
qc^[1] := jl;

{ do the LEE }

while (li <= ls) do
  begin
    f := qf^[li];
    i := ql^[li];
    j := qc^[li];

    for k := 1 to nv^[f, i, j] do
      begin
        fne := fv[k]^[f, i, j];
        ine := lv[k]^[f, i, j];
        jne := cv[k]^[f, i, j];

        if (di^[fne, ine, jne] > di^[f, i, j] + 1) and
           (c^[fne, ine, jne] = 0)
        then
          begin
            di^[fne, ine, jne] := di^[f, i, j] + 1;

            ls := ls + 1;
            qf^[ls] := fne;
            ql^[ls] := ine;
            qc^[ls] := jne;
          end;
      end;

    li := li + 1;
  end;

{ calculeaza raspunsul }

dmin := INF;
count := 0;

for f := 1 to FMAX do
  for i := 1 to N do
    for j := 1 to N do
      if (trapa^[f, i, j] = 1) then
        begin
          if (di^[f, i, j] < dmin) then
            begin
              dmin := di^[f, i, j];
              count := 1;
            end
          else
          if (di^[f, i, j] = dmin) then
            begin
              count := count + 1;
            end;
        end;

assign(output, 'cub.out');
rewrite(output);
writeln(dmin);
writeln(count);
close(output);
end.
