/* Tiberiu Danet, 2006 */

#include <cstdio>
#include <cstring>

#define N_MAX  32
#define MAGIC  30103

int N, M, H, K, Res;
// combinarile care au N, M, H jos
int combN[N_MAX], combM[N_MAX], combH[N_MAX];
// combinarile care au K sus
int combK[N_MAX * N_MAX * N_MAX];

int comb[N_MAX * N_MAX * N_MAX];


void compute_comb ()
{
   int i, j, start;
   
   comb[0] = 1;
   for (i = 1; i <= N * M * H; i++)
   {
      start = (i > N && i > M && i > H && K < i) ? K : i;
      
      for (j = start; j >= 1; j--)
         comb[j] = (comb[j] + comb[j - 1]) % MAGIC;
         
      combK[i] = comb[K];
         
      if (i == N)
         memccpy(combN, comb, -1, (N + 1) * sizeof(int));
         
      if (i == M)
         memccpy(combM, comb, -1, (M + 1) * sizeof(int));

      if (i == H)
         memccpy(combH, comb, -1, (H + 1) * sizeof(int));
   }
}

void solve ()
{
   int i, j, k, r, sgn;
   
   if (K > N * M * H)
      return;
   
   for (i = 0; i <= N; i++)
      for (j = 0; j <= M; j++)
         for (k = 0; k <= H; k++)
         {
            sgn = ((i + j + k) % 2 == 0) ? 1 : -1;
            r = (combN[i] * combM[j]) % MAGIC;
            r = (r * combH[k]) % MAGIC;
            r = (r * combK[(N - i) * (M - j) * (H - k)]) % MAGIC;
            r = (MAGIC + sgn * r) % MAGIC;
            Res = (Res + r) % MAGIC;
         }
}

void read_solve ()
{
   freopen("borg.in", "r", stdin);
   freopen("borg.out", "w", stdout);
   
   scanf("%d%d%d%d", &N, &M, &H, &K);
   
   compute_comb();   
   solve();
   
   printf("%d\n", Res);
}

int main ()
{
   read_solve();
   return 0;
}
