/* Emilian Miron */

#include <cstdio>
#include <cassert>

#define maxn 21
#define prime 30103

int invmod (int x)
{
    int p = prime - 2, rv = 1, oldx = x;
    for (; p; p /= 2) {
      rv = p & 1 ? x * rv % prime : rv;
      x = x*x % prime;
    }

    assert ((rv * oldx % prime) == 1);
    return rv;
}

int C[maxn][maxn], N, M, H, K, CM[maxn*maxn*maxn];

int main()
{
    int i, j, k, MAX, sol;

    freopen ("borg.in", "rt", stdin);
    freopen ("borg.out", "wt", stdout);

    scanf ("%d%d%d%d", &N, &M, &H, &K);

    MAX = N >? M >? H;

    assert (MAX < maxn && K <= N*M*H);

    C[0][0] = 1;

    for (i = 1; i <= MAX; i++) {
       C[i][0] = 1;
       for (j = 1; j <= MAX; j++)
          C[i][j] = (C[i-1][j-1] + C[i-1][j]) % prime;
    }

    CM[K] = 1;
    for (k = K + 1; k <= N*M*H; k++)
       CM[k] = CM[k - 1]*k%prime*invmod(k - K)%prime;

    for (sol = 0, i = 0; i < N; i++)
    for (j = 0; j < M; j++)
    for (k = 0; k < H; k++) {
       sol = sol + C[N][i]* C[M][j]%prime*C[H][k]%prime
              * CM[(N-i)*(M-j)*(H-k)] % prime *
              (((i+j+k)%2) ? -1 : 1);
       for (; sol < 0; sol += prime);
       sol %= prime;
    }

    fprintf (stderr, "K, NMH: %d %d\n", K, N*M*H);


    printf ("%d\n", sol);

    return 0;
}

