{
  marian's solution
}

program kruskal1;
uses sysutils;

{$apptype console}

const VMAX = 100000;
      EMAX = 200000;
      inputfile = 'vitale.in';
      outputfile = 'vitale.out';

type node = ^element;
     element=record
          vertex, index:longint;
          next:node;
     end;

var a:array[1..VMAX] of node;
    x, y, w:array[1..EMAX + 1] of longint;
    n, m:longint;

    father, weigth, dfs_num, low:array[1..VMAX] of longint;
    dfs_nr:longint;

    critical: array[1..EMAX] of boolean;

procedure read_data;
var fil:text;
    i:longint;
begin
  assign(fil, inputfile);reset(fil);
  readln(fil, n, m);
  for i := 1 to m do readln(fil, x[i], y[i], w[i]);
  close(fil);
end;

var aux, mid:longint;
procedure qsort(lo, hi:longint);
var i, j:longint;
begin
  i := lo; j := hi; mid := w[(i + j) shr 1];
  repeat
    while w[i] < mid do inc(i);
    while w[j] > mid do dec(j);
    if i <= j then begin
       aux := x[i]; x[i] := x[j]; x[j] := aux;
       aux := y[i]; y[i] := y[j]; y[j] := aux;
       aux := w[i]; w[i] := w[j]; w[j] := aux;
       inc(i); dec(j);
    end;
  until i > j;
  if lo < j then qsort(lo, j);
  if i < hi then qsort(i, hi);
end;

function root(x :longint):longint;
begin
 if father[x] = 0 then root := x
 else begin
   father[x] := root(father[x]);
   root := father[x];
 end;
end;

procedure join(x, y:longint);
begin
 if weigth[x] > weigth[y] then begin
    father[y] := x;
 end else if weigth[x] < weigth[y] then begin
    father[x] := y;
 end else begin
    father[y] := x;
    inc(weigth[x]);
 end;
end;

procedure dfs(xx, edge_index:longint);
var nd:node;
    yy:longint;
begin
  inc(dfs_nr);
  dfs_num[xx] := dfs_nr;
  low[xx] := dfs_nr;
  nd := a[xx];
  while nd <> nil do begin
     yy := root(nd^.vertex);
     if dfs_num[yy] = 0 then begin
        dfs(yy, nd^.index);
        if low[yy] = dfs_num[yy] then begin
           critical[nd^.index] := true;
        end;
        if low[yy] < low[xx] then low[xx] := low[yy];
     end else if nd^.index <> edge_index then
        if dfs_num[yy] < low[xx] then low[xx] := dfs_num[yy];
     nd := nd^.next;
  end;
end;

procedure kruskal;
var i, j, k:longint;
    nd:node;
begin

  qsort(1, m);
  w[m + 1] := w[m] + 1;

  fillchar(father, sizeof(father), 0);
  fillchar(weigth, sizeof(weigth), 0);
  fillchar(a, sizeof(a), 0);
  fillchar(critical, sizeof(critical), false);

  j:=1;
  for i := 1 to m + 1 do begin
      if w[j] <> w[i] then begin

        for k := j to i - 1 do begin
            a[root(x[k])] := nil;
            a[root(y[k])] := nil;
            dfs_num[root(x[k])] := 0;
            low[root(x[k])] := 0;
            dfs_num[root(y[k])] := 0;
            low[root(y[k])] := 0;
        end;

        for k := j to i - 1 do begin
            new(nd);
            nd^.vertex := root(y[k]);
            nd^.index := k;
            nd^.next := a[root(x[k])];
            a[root(x[k])] := nd;

            new(nd);
            nd^.vertex := root(x[k]);
            nd^.index := k;
            nd^.next := a[root(y[k])];
            a[root(y[k])] := nd;
        end;

        dfs_nr := 0;
        for k := j to i - 1 do begin
            if dfs_num[root(x[k])] = 0 then dfs(root(x[k]), 0);
        end;

        for k := j to i - 1 do begin
            if root(x[k]) <> root(y[k]) then begin
              join(root(x[k]), root(y[k]));
            end;
        end;
        j := i;
      end;
  end;
end;

var midx, midy:longint;
procedure qsort1(lo, hi:longint);
var i, j:longint;
begin
  i := lo; j := hi;
  midx := x[(lo + hi) shr 1];
  midy := y[(lo + hi) shr 1];
  repeat
    while (x[i] < midx)
      or ((x[i] = midx) and (y[i] < midy)) do inc(i);
    while (x[j] > midx)
      or ((x[j] = midx) and (y[j] > midy)) do dec(j);
    if i <= j then begin
       aux := x[i]; x[i] := x[j]; x[j] := aux;
       aux := y[i]; y[i] := y[j]; y[j] := aux;
       inc(i); dec(j);
    end;
  until i > j;
  if lo < j then qsort1(lo, j);
  if i < hi then qsort1(i, hi);
end;

procedure write_data;
var  fil:text;
     i, nr, xx, yy:longint;
begin
NR:=0;
  for i := 1 to m do
    if critical[i] then begin
      inc(nr);
      if (x[i] <= y[i]) then begin
        x[nr] := x[i];
        y[nr] := y[i];
      end else begin
        xx:= x[i];
        yy:=y[i];
        x[nr] := yy;
        y[nr] := xx;
      end;
  end;
  qsort1(1, nr);

  assign(fil, outputfile);rewrite(fil);
  writeln(fil, nr);
  for i := 1 to nr do
     writeln(fil, x[i], ' ', y[i]);
  close(fil);
end;



begin
  read_data;
  kruskal;
  write_data;
end.
