# include <stdio.h>
# include <string.h>
# include <stdlib.h>

# define _fin  "diamant.in"
# define _fout "diamant.out"

# define maxn 22
# define smax 45202

# define mod  10000


int a[maxn*maxn], m, n, x, vn;
int sol;


void readf()
{
    FILE *fin = fopen(_fin, "r");
    fscanf(fin, "%d %d %d", &m, &n, &x), fclose(fin);
}

void writef()
{
    FILE *fout= fopen(_fout,"w");
    fprintf(fout, "%d\n", sol), fclose(fout);
}

int qs_poz(int st, int dr)
{
    int x=a[st];

    while( st < dr )
    {
	while ( st < dr && a[dr] >= x ) dr--; a[st] = a[dr];
	while ( st < dr && a[st] <= x ) st++; a[dr] = a[st];
    }

    a[st] = x;
    return st;
}

void qs_norm(int st, int dr)
{
    int m = qs_poz(st, dr);
    if ( st < m ) qs_norm(st, m-1);
    if ( m < dr ) qs_norm(m+1, dr);
}

void precompute()
{
    int i, j;

    for(i=1; i<=n; i++)
	for(j=1; j<=m; j++)
	    a[ (i-1)*m+j ] = i*j;

    qs_norm(1, vn = m*n);
}

void solve()
{
    int i, j, vcmax=0, aux, ind, stot;
    int b[2*smax], nb[2*smax];

    if ( x > ( (n*(n+1))>>1 ) * ( (m*(m+1))>>1 ) ) return; // no solution

    memset(b, 0, sizeof(b));
    memset(nb,0, sizeof(nb));
    b[smax]=nb[smax]=1;

    for(i=1; i<=vn; i++)
    {
	for(j=-vcmax; j<=vcmax; j++)
	{
	    aux=b[ind=j+smax];
	    if ( aux )
	    {
		nb[ind+a[i]] = (aux+nb[ind+a[i]]) % mod;
		nb[ind-a[i]] = (aux+nb[ind-a[i]]) % mod;
	    }
	}
	vcmax += a[i];

	memcpy(b, nb, sizeof(nb));
    }

    sol = nb[smax+x];
}

int main()
{
    readf();
    precompute();
    solve();
    writef();

    return 0;
}