#include <stdio.h>
#define MAX 50001


struct nod
{
	long int x, y, cost;
}a[2 * MAX], arb[2 * MAX], aux;

long int n, m;
long int costmin, nr;
long int t[MAX], h[MAX];



void citire ();
void kruskal ();
void init ();
void qsort ( long int i, long int j );
void uunion ( int i, int j );
void afisare ();
void qsort1 ( long int i, long int j );

long int find ( long int i );



int main ()
{
	freopen ( "vitale.in", "r", stdin );
	freopen ( "vitale.out", "w", stdout );

	citire ();
	kruskal ();
	afisare ();

	return 0;
}

void citire ()
{
	long int i;

	scanf ( "%ld %ld", &n, &m );

	for ( i = 1; i <= m; i++ )
		scanf ( "%ld %ld %ld", &a[i].x, &a[i].y, &a[i].cost );

//	for ( i = 1; i <= m; i++ )
//		printf ( "%ld %ld %ld\n", a[i].x, a[i].y, a[i].cost );
}

void kruskal ()
{
	long int i, j, r1, r2;

	qsort ( 1, m );
//	for ( i = 1; i <= m; i++ )
//		printf ( "%ld %ld %ld\n", a[i].x, a[i].y, a[i].cost );

	init ();
	for ( i = 1; i <= m; i++ )
	{
		r1 = find ( a[i].x );
		r2 = find ( a[i].y );

		if ( r1 != r2 )
		{
			nr++;
			arb[nr] = a[i];
			uunion ( r1, r2 );
			costmin += a[i].cost;

			if ( nr == n - 1 )
				break;
		}
	}
}

void qsort ( long int prim, long int ultim )
{
	long int i, j, mij;

	i = prim;
	j = ultim;
	mij = a[(i + j) / 2].cost;

	do
	{
		while ( a[i].cost < mij )
			i++;
		while ( a[j].cost > mij )
			j--;
		if ( i <= j )
		{
			aux = a[i];
			a[i] = a[j];
			a[j] = aux;

			i++;
			j--;
		}
	}
	while ( i < j );

	if ( i < ultim )
		qsort ( i, ultim );
	if ( j > prim )
		qsort ( prim, j );
}

void init ()
{
	long int i;

	for ( i = 1; i <= n; i++ )
	{
		t[i] = i;
		h[i] = 0;
	}
}

long int find ( long int nod )
{
	long int f, rad;

	rad = nod;
	while ( rad != t[rad] )
		rad = t[rad];

	while ( nod != rad )
	{
		f = t[nod];
		t[nod] = rad;
		nod = f;
	}

	return rad;
}

void uunion ( int x, int y )
{
	if ( h[x] > h[y] )
		t[y] = x;
	else
	{
		t[x] = y;

		if ( h[x] == h[y] )
			h[y]++;
	}
}

void afisare ()
{
	int i, j, ind;

	for ( i = 1; i <= nr; i++ )
		if ( arb[i].x > arb[i].y )
		{
			ind = arb[i].x;
	   		arb[i].x = arb[i].y;
			arb[i].y = ind;
		}
	qsort1 ( 1, nr );


	printf ( "%ld\n", nr );
	for ( i = 1; i <= nr; i++ )
		printf ( "%ld %ld\n", arb[i].x, arb[i].y );
}

void qsort1 ( long int prim, long int ultim )
{
	long int i, j, mijx, mijy;

	i = prim;
	j = ultim;
	mijx = arb[(i + j) / 2].x;
	mijy = arb[(i + j) / 2].y;

	do
	{
		while ( arb[i].x < mijx || (arb[i].x == mijx && arb[i].y < mijy ) )
			i++;
		while ( arb[j].x > mijx || (arb[i].x == mijx && arb[j].y > mijy ) )
			j--;
		if ( i <= j )
		{
			aux = arb[i];
			arb[i] = arb[j];
			arb[j] = aux;
			i++;
			j--;
		}
	}
	while ( i < j );

	if ( i < ultim )
		qsort1 ( i, ultim );
	if ( j > prim )
		qsort1 ( prim, j );
}