#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXN 50010
#define MAX_M 100010
#define swap(x,y) (x^=y, y^=x, x^=y)

typedef struct muchie { int u, v, c; } edge;

int N, M;
edge A[MAX_M];

int *G[MAXN], tata[MAXN], rank[MAXN];
int uz[MAX_M], ok[MAX_M], viz[MAXN];

int find(int x)
{
	int root, p = x;
	while(tata[p])
		p = tata[p];
    root = p, p = x;
	while(p != root)
		tata[p] = root, p = tata[p];
    return root;
}

void uneste(int x, int y)
{
	int rx, ry;
	rx = find(x), ry = find(y);
	if(rx == ry) return ;
	if(rank[rx] > rank[ry]) tata[ry] = rx;
	if(rank[ry] > rank[rx]) tata[rx] = ry;
	if(rank[rx] == rank[ry]) tata[ry] = rx, rank[rx]++;
}

int cmp_cost(const void *a, const void *b)
{
	return (*(edge*)a).c - (*(edge*)b).c;
}

void add_edge(int u, int v)
{
	G[u][0]++, G[v][0]++;
	G[u] = (int*) realloc(G[u], sizeof(int)*(G[u][0]+2));
	G[v] = (int*) realloc(G[v], sizeof(int)*(G[v][0]+2));
	G[u][G[u][0]] = v, G[v][G[v][0]] = u;
}

void dfs(int x)
{
	int v, i;
	for(i = 1; i <= G[x][0]; i++)
	{
		v = G[x][i];
		if(!viz[v])
			viz[v] = 1, tata[v] = x, dfs(v);
    }
}

int cmp_order(const void *a, const void *b)
{
	if( (*(edge*)a).u != (*(edge*)b).u )
		return (*(edge*)a).u - (*(edge*)b).u;
    return (*(edge*)a).v - (*(edge*)b).v;
}

edge R[MAX_M];
int X;

int poz(int x, int y)
{
	int st = 0, dr = M-1, m, rez;
	while(st <= dr)
	{
		m = (st+dr) >> 1;
		if(R[m].u < x || (R[m].u == x && R[m].v <= y))
			rez = m, st = m+1;
        else
			dr = m-1;
    }
	return rez;
}

void verifica(int x, int y, int cost)
{
	int p, a, b, t;
	p = x;
	viz[1] = 1;
	while(tata[p])
		viz[p] = 1, p = tata[p];
    p = y;
	while(!viz[p])
	{
		a = p, b = tata[p];
		if(a > b) swap(a,b);
		t = poz(a, b);
		if(R[t].c == cost) ok[t] = 0;
    	p = tata[p];
    }
	p = x, viz[1] = 0;
    while(tata[p])
		viz[p] = 0, p = tata[p];
}

void solve(void)
{
	int i, chk, ind, c, x, y, nr, p, lastcost, t, a, b, cost;
	
	for(i = 1; i <= N; i++)
		G[i] = (int*) realloc(G[i], sizeof(int)), G[i][0] = 0;

    qsort(A, M, sizeof(A[0]), cmp_cost);
	memcpy(R, A, sizeof(A));
	qsort(R, M, sizeof(R[0]), cmp_order);

	ind = 0, nr = 0;
	while(nr < N-1)
	{
		x = A[ind].u, y = A[ind].v;
		while( find(x) == find(y) )
			ind++, x = A[ind].u, y = A[ind].v;
        add_edge(x, y), uneste(x, y), uz[ind] = 1, ind++, nr++;
		t = poz(x, y);
 		ok[t] = 1;
    }

	memset(tata, 0, sizeof(tata));

	viz[1] = 1, dfs(1), memset(viz, 0, sizeof(viz));

	for(lastcost = -1, i = 0; i < M; i++)
	 if(!uz[i] && lastcost == A[i].c)
	 {
	 	cost = A[i].c, x = A[i].u, y = A[i].v;
		verifica(x, y, cost), verifica(y, x, cost);
     }
	 else
	 {
	 	if(uz[i])
			lastcost = A[i].c;
     }
}

void read_data(void)
{
	int i, u, v, c;

	scanf("%d %d\n", &N, &M);

	for(i = 1; i <= M; i++)
	{
		scanf("%d %d %d\n", &u, &v, &c);
		if(u > v) swap(u, v);
		A[i-1].u = u, A[i-1].v = v, A[i-1].c = c;
    }
}

void write_data(void)
{
	int i;
	for(i = 0; i < M; i++)
     if(ok[i])
		X++;
    printf("%d\n", X);
	for(i = 0; i < M; i++)
	 if(ok[i])
	 	printf("%d %d\n", R[i].u, R[i].v);
}

int main(void)
{
	freopen("vitale.in", "rt", stdin);
	freopen("vitale.out", "wt", stdout);

	read_data();
	solve();
	write_data();

	return 0;
}




		


		
	







