#include <stdio.h>
#include <stdlib.h>

#define MAX_VARF 50001
#define MAX_MUCHIE 100001

typedef long long bigt;

struct Muchie
{
    int v1, v2;
    int c;
    char a;
};

Muchie graf[ MAX_MUCHIE ], *apm[ MAX_MUCHIE ], sol[MAX_MUCHIE];
int m, n, m_apm, m_sol;
bigt cost_apm;

int cmp( const void *_a, const void *_b )
{
    Muchie *a = (Muchie*)_a;
    Muchie *b = (Muchie*)_b;
    if( a->c == b->c ) return 0;
    if( a->c > b->c) return 1;
    return -1;
}

int cmp_lex( const void *_a, const void *_b )
{
    Muchie *a = (Muchie*)_a;
    Muchie *b = (Muchie*)_b;
    if( (a->v1 > b->v1) || ( a->v1 == b->v1 && a->v2 > b->v2 ) ) return 1;
    return -1;
}

inline int min( int a, int b )
{
    if( a>b ) return b;
    return a;
}

inline int max( int a, int b )
{
    if( a>b ) return a;
    return b;
}

void replace( int *vect, int st, int f, int v, int nv )
{
    for( int i=st; i<f; i++ )
         if( vect[i] == v ) vect[i] = nv;
}

bigt make_apm()
{
    int varf[ MAX_VARF ];
    bigt cost = 0;

    for( int i=1; i<=n; i++ ) varf[i] = i;

    m_apm = 0;
    int k = 0;
    while( m_apm < n-1 )
    {
        if( varf[ graf[k].v1 ] != varf[ graf[k].v2 ] && graf[k].a )
        {
            apm[ m_apm++ ] = &graf[k];
            replace( varf, 1, n, varf[graf[k].v1], varf[graf[k].v2] );
            cost += graf[k].c;
        }
        k++;
    }
    return cost;
}

bigt get_cost_apm()
{
    int varf[ MAX_VARF ];
    bigt cost = 0;

    for( int i=1; i<=n; i++ ) varf[i] = i;
    
    int m_apm_cost = 0;
    int k = 0;
    
    while( m_apm_cost < n-1 )
    {
        if( varf[ graf[k].v1 ] != varf[ graf[k].v2 ] && graf[k].a == 1 )
        {
            m_apm_cost++;
            replace( varf, 1, n, varf[graf[k].v1], varf[graf[k].v2] );
            cost += graf[k].c;
        }
        k++;
    }
    return cost;
}

int citire()
{
    FILE *f = fopen("vitale.in", "r" );
    if( !f ) return 0;

    fscanf( f, "%d %d", &n, &m );
    for( int i=0; i<m; i++ )
    {
        fscanf( f, "%d %d %d", &graf[i].v1, &graf[i].v2, &graf[i].c );
        graf[i].a = 1;
    }
    fclose( f );
    return 1;
}

inline Muchie aranj( Muchie m )
{
    int v1 = min( m.v1, m.v2 );
    int v2 = max( m.v1, m.v2 );
    m.v1 = v1; m.v2 = v2;
    return m;
}

int main()
{
    if( !citire() ) return 1;

    qsort( graf, m, sizeof(Muchie), cmp );

    cost_apm = make_apm();

    m_sol  = 0;
    for( int i=0; i<m_apm; i++ )
    {
        apm[i]->a = 0;
        if( cost_apm != get_cost_apm() )
        {
              sol[ m_sol++ ] = aranj( *apm[i] );
        }
        apm[i]->a = 1;
    }

    qsort( sol, m_sol, sizeof(Muchie), cmp_lex );

    FILE *f = fopen( "vitale.out", "w" );
    fprintf( f,"%d\n", m_sol );
    for( int i=0; i<m_sol; i++ )
         fprintf( f, "%d %d\n", sol[i].v1, sol[i].v2 );
    fclose(f);

    return 0;
}
