#include <stdio.h>
#define Infile "vitale.in"
#define Outfile "vitale.out"
#define DIM 100010
#define DIM2 50010

long int n, m, nr, t[DIM2], comp[DIM2];
long int costmax;
long int sel[DIM], nrsol;
long int ax[DIM2], ay[DIM2];

struct edge {
	long int x, y, c;
} edges[DIM], apm[DIM], aux;

void Read();
void Solve();
void Write();
void QuickSort ( long int l, long int r );
long int  Find ( long int x );
void Union ( long int x, long int y );
void  Qsort ( long int l, long int r );

int main()
{
	Read();
	Solve();
	Write();

	return 0;
}

void Read()
{
	freopen(Infile,"r",stdin);

	scanf("%ld%ld",&n,&m);

	long int i;

	for ( i = 1; i <= n; i++ )
	{
		comp[i] = i;
		t[i] = i;
	}

	for ( i = 1; i <= m; i++ )
		scanf("%ld%ld%ld",&edges[i].x,&edges[i].y,&edges[i].c);

	fclose(stdin);
}

void Solve()
{
	QuickSort(1,m);

	long int i, ii, jj;

	for ( i = 1; i <= m; i++ )
	{
		ii = Find(edges[i].x);
		jj = Find(edges[i].y);

		if ( comp[ii] != comp[jj] )
		{
			Union(ii,jj);
			nr++;
			apm[nr].x = edges[i].x;
			apm[nr].y = edges[i].y;
			apm[nr].c = edges[i].c;
			costmax += edges[i].c;
		}
	}

	long int inew, jnew, j, cost;
	for ( j = 1; j <= nr; j++ )
	{
		inew = apm[j].x;
		jnew = apm[j].y;
		cost = 0;

		for ( i = 1; i <= n; i++ )
		{
			comp[i] = i;
			t[i] = i;
		}

		for ( i = 1; i <= m; i++ )
		if ( edges[i].x != inew || edges[i].y != jnew )
		{
			ii = Find(edges[i].x);
			jj = Find(edges[i].y);

			if ( comp[ii] != comp[jj] )
			{
				Union(ii,jj);
				cost += edges[i].c;
			}
		}

		if ( cost != costmax )
		{
			nrsol++;
			sel[j] = 1;
		}
	}

}

void QuickSort ( long int l, long int r )
{
	long int i = l - 1, j = r + 1, piv = edges[r].c;

	do
	{
		do { i++; } while ( edges[i].c < piv );
		do { j--; } while ( edges[j].c > piv );

		if ( i <= j )
		{
			aux = edges[i];
			edges[i] = edges[j];
			edges[j] = aux;
		}
	} while ( i <= j );

	if ( i < r ) QuickSort(i,r);
	if ( j > l ) QuickSort(l,j);
}

long int Find ( long int x )
{
	if ( x != t[x] ) x = Find(t[x]);
	return t[x];
}

void Union ( long int x, long int y )
{
	if ( comp[x] < comp[y] )
	{
		comp[x] = comp[y];
		t[x] = y;
	}
	else
	{
		comp[y] = comp[x];
		t[y] = x;
	}
}

void Write()
{
	freopen(Outfile,"w",stdout);

	long int i, j;
	j = 0;

	printf("%ld\n",nrsol);

	for ( i = 1; i <= nr; i++ )
		if ( sel[i] )
		{
			j++;
			if ( apm[i].x > apm[i].y )
			{
				ax[j] = apm[i].y;
				ay[j] = apm[i].x;
			}
			else
			{
				ax[j] = apm[i].x;
				ay[j] = apm[i].y;
			}
		}
	Qsort(1,nrsol);

	for ( i = 1; i <= nrsol; i++ )
		printf("%ld %ld\n",ax[i],ay[i]);


	fclose(stdout);
}

void Qsort ( long int l, long int r )
{
	long int i = l - 1, j = r + 1, piv = ax[r];
	int aux;

	do
	{
		do { i++; } while ( ax[i] < piv || ax[i] == piv && ay[i] < ay[r] );
		do { j--; } while ( ax[j] > piv || ax[j] == piv && ay[j] > ay[r] );

		if ( i <= j )
		{
			aux = ax[i];
			ax[i] = ax[j];
			ax[j] = aux;
			aux = ay[i];
			ay[i] = ay[j];
			ay[j] = aux;
		}
	} while ( i <= j );

	if ( i < r ) Qsort(i,r);
	if ( j > l ) Qsort(l,j);
}






