#include <iostream.h>
#include <fstream.h>

#define MAXINT      32565

#define InFile   "vitale.in"
#define OutFile "vitale.out"

ifstream   fin( InFile );
ofstream fout( OutFile );

///////////////////////////////////////////////////////////////////
// struct pt lista graf
struct NOD
{
	int varf;
	long cost;

    NOD *urm;
};

// clasa Graf
class Graf
{
public:
	Graf( int nrVarfuri, int nrMuchii )
	{
		m_nrVarfuri = nrVarfuri;
		m_nrMuchii = nrMuchii;

		ult = new NOD;

		m = new NOD*[m_nrVarfuri];
		for( int i = 0; i < m_nrVarfuri; i++ )
		{
			m[i] = new NOD;
			m[i]->urm = ult;
		}
	}

	~Graf()
	{
    	delete m, ult;
    }

	int GetNrVarfuri() { return m_nrVarfuri; }
	NOD* GetLista( int i ) { return m[i]->urm; }

	int AdaugaVecin( int varf, int vecin, long cost )
	{
		NOD *c = new NOD;

		c->varf = vecin;
		c->cost = cost;

		c->urm = m[varf]->urm;
		m[varf]->urm = c;

		c = new NOD;
		c->varf = varf;
		c->cost = cost;

		c->urm = m[vecin]->urm;
		m[vecin]->urm = c;

    }

    NOD* GetSantinela() { return ult; }

private:
	int m_nrVarfuri, m_nrMuchii;
    NOD *ult;
    NOD **m;
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
// struct pt Coada

struct NODD
{
	int inf;
    NODD *urm, *prec;
};

// clasa Coada
class Coada
{
public:
	Coada()
	{
		cap = new NODD;
		coada = new NODD;

		cap->prec = coada;
        coada->urm = cap;
	}

	~Coada()
	{
    	delete cap, coada;
    }

	int EsteVida() { return cap->prec == coada; }

	void Adauga( int x )
	{
		NODD *c = new NODD;

		c->inf = x;

		coada->urm->prec = c;
        c->urm = coada->urm;
		coada->urm = c;
		c->prec = coada;
	}

	int Scoate()
	{
		if( !EsteVida() )
        {
			NODD *r = cap->prec;

			int x = r->inf;

			r->prec->urm = r->urm;
			r->urm->prec = r->prec;

			delete r;

			return x;
		}

        return -1;
	}

	int Apartine( int x )
	{
		NODD *c = cap->prec;
		while( c != coada )
		{
			if( c->inf == x )
				return 1;

            c = c->prec;
		}

        return 0;
    }

private:
	NODD *cap, *coada;
};
///////////////////////////////////////////////////////////////////


class AcoperireMinima
{
public:
	AcoperireMinima( Graf *g )
	{
		G = g;

		d = new long[G->GetNrVarfuri()];
		preci = new int[G->GetNrVarfuri()];
        precf = new int[G->GetNrVarfuri()];

		for( int i = 0; i < G->GetNrVarfuri(); i++ )
		{
			d[i] = MAXINT;
            precf[i] = -1;
            Q.Adauga( i );
		}

		GenSol( precf );

        int sp = 0;
		for( i = 0; i < G->GetNrVarfuri(); i++ )
			if( precf[i] != -1 )
            	sp += d[i];


		for( i = 1; i < G->GetNrVarfuri(); i++ )
		{
			for( int j = 0; j < G->GetNrVarfuri(); j++ )
			{
				d[j] = MAXINT;
				preci[j] = -1;
                if( i + j < G->GetNrVarfuri() )
					Q.Adauga( i + j );
				else
                	Q.Adauga( i + j - G->GetNrVarfuri() );
			}

			GenSol( preci );

            int s = 0;
			for( j = 0; j < G->GetNrVarfuri(); j++ )
				if( preci[j] != -1 )
					s+= d[j];

			if( sp < s )
				continue;

			if( sp > s )
			{
				for( j = 0; j < G->GetNrVarfuri(); j++ )
					precf[j] = preci[j];

                continue;
            }
            
			for( j = 0; j < G->GetNrVarfuri(); j++ )
				if( precf[j] != -1 && precf[j] != preci[j] && preci[precf[j]] != j )
					precf[j] = -1;
		}
	}

	void GenSol( int *prec )
	{
		while( !Q.EsteVida() )
		{
			int u = Q.Scoate();
			NOD *c = G->GetLista( u );
			while( c != G->GetSantinela() )
			{
				int v = c->varf;
				long cost = c->cost;

				if( Q.Apartine( v ) && d[v] > cost )
				{
					d[v] = cost;
                    prec[v] = u;
				}

                c = c->urm;
            }
		}
	}

	void AfisSol()
	{
    	int n = 0;
		for( int i = 0; i < G->GetNrVarfuri(); i++ )
			for( int j = i + 1; j < G->GetNrVarfuri(); j++ )
				if( precf[j] == i || precf[i] == j )
					n++;

		fout << n << endl;
		for( i = 0; i < G->GetNrVarfuri(); i++ )
			for( int j = i + 1; j < G->GetNrVarfuri(); j++ )
				if( precf[j] == i || precf[i] == j )
					fout << i + 1 << " " << j + 1 << endl;
    }

private:
	Graf *G;
    Coada Q;
	long *d;
	int *preci, *precf;
};

int main()
{
	int n;
	long m;
	fin >> n >> m;
	Graf G( n, 0 );
	for( long i = 0; i < m; i++ )
	{
		int x, y;
        long cost;
		fin >> x >> y >> cost;
		G.AdaugaVecin( x - 1, y - 1, cost );
	}

	AcoperireMinima AM( &G );
    AM.AfisSol();

	return 0;
}