using namespace std;

#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <set>
#include <algorithm>

#define FIN "vitale.in"
#define FOUT "vitale.out"

#define pb push_back
#define mp make_pair

#define MAX_N 50010

#define INFTY 0x3f3f3f3f

typedef long long ll;

typedef struct node
{
	int nd, id;
	int cost;
	node *lnk;
} node;	

struct entry
{
	int a, b, c;
	entry() {}
	entry(int _a, int _b, int _c) {a = _a, b = _b, c = _c;}
} v[MAX_N<<1];

bool operator<(const entry &x, const entry &y)
{
	return x.c < y.c;
}

int nv, up[MAX_N], ok[MAX_N];

int N, M, me[MAX_N], F[MAX_N], tcost[MAX_N], inm[MAX_N], lev[MAX_N];
node *G[MAX_N];
multiset<int> MS;
vector<int> dsc[MAX_N], dbg[MAX_N], adj[MAX_N];

int U[MAX_N], H[MAX_N], pos[MAX_N], hs;
vector<pair<int, int> > sol;

void add_edge(int a, int b, int c, int id)
{
	node *p = (node*)malloc(sizeof(node));
	p->nd = b, p->cost = c;
	p->id = id;
	p->lnk = G[a], G[a] = p;
}

void read()
{
	int i, a, b;
	ll c;
	FILE *fi = fopen(FIN, "r");
	fscanf(fi, "%d%d", &N, &M);
	for (i = 1; i <= N; ++i)
		G[i] = NULL;
	for (i = 0; i < M; ++i) {
		fscanf(fi, "%d%d%d", &a, &b, &c);
		add_edge(a, b, c, i);
		add_edge(b, a, c, i);
	}
	fclose(fi);
}

void swap(int x, int y)
{
	H[x] ^= H[y] ^= H[x] ^= H[y];
	pos[H[x]] ^= pos[H[y]] ^= pos[H[x]] ^= pos[H[y]];
}

void sift(int x)
{
	int i, mx;
	for (mx = x, i = 0; i < 2; ++i)
		if ((x<<1)+i < hs && me[H[(x<<1)+i]] < me[H[mx]])
			mx = (x<<1)+i;
	if (mx != x) {
		swap(x, mx);
		sift(mx);
	}
}

void percolate(int x)
{
	if (x > 1 && me[H[x>>1]] > me[H[x]]) {
		swap(x, x>>1);
		percolate(x>>1);
	}
}

int extract()
{
	int res = H[1];
	swap(1, hs--);
	if (hs)
		sift(1);
	return res;
}

void get_lev(int n)
{
	vector<int>::iterator it;
	for (it = adj[n].begin(); it != adj[n].end(); ++it) {
		lev[*it] = lev[n]+1;
		get_lev(*it);
	}
}

void DFS(int n)
{
	vector<int>::iterator it;
	for (it = adj[n].begin(); it != adj[n].end(); ++it) {
		DFS(*it);
	}
}

void baga(int a, int b, int c)
{
	for (a = up[a]; lev[a] > lev[b]; a = F[a]) {
		if (lev[b] < lev[up[a]])
			up[a] = b;
		if (c <= tcost[a])
			ok[a] = 0;
	}
}

int lca(int a, int b)
{
	while (lev[a] > lev[b])
		a = F[a];
	while (a != b) {
		a = F[a];
		b = F[b];
	}
	return a;
}

void solve()
{
	int i, j, n;
	node *p;
	memset(me, INFTY, sizeof(me));
	memset(U, 0, sizeof(U));
	me[1] = 0;
	for (i = 1; i <= N; ++i)
		H[i] = pos[i] = i;
	hs = N;
	for (i = 1; i <= N; ++i) {
		n = extract();
		U[n] = 1;
		for (p = G[n]; p != NULL; p = p->lnk)
			if (!U[p->nd] && p->cost < me[p->nd]) {
				F[p->nd] = n;
				tcost[p->nd] = p->cost;
				me[p->nd] = p->cost;
				percolate(pos[p->nd]);
			}
	}
	memset(inm, 0, sizeof(inm));
	for (i = 2; i <= N; ++i)
		for (p = G[i]; p; p = p->lnk)
			if (F[i] == p->nd) {
				inm[p->id] = 1;
				adj[p->nd].pb(i);
			}
	lev[1] = 1, get_lev(1);
	for (nv = 0, i = 1; i <= N; ++i)
		for (p = G[i]; p != NULL; p = p->lnk)
			if (!inm[p->id] && lev[i] < lev[p->nd])
				v[nv++] = entry(p->nd, i, p->cost);
	sort(v, v+nv);
	for (i = 1; i <= N; ++i) {
		up[i] = i;
		ok[i] = 1;
	}
	int l;
	for (i = 0; i < nv; ++i) {
		l =  lca(v[i].a, v[i].b);
		baga(v[i].a, l, v[i].c);
		baga(v[i].b, l, v[i].c);
	}
	for (i = 2; i <= N; ++i)
		if (ok[i]) {
			int a = i, b = F[i];
			if (a > b)
				a ^= b ^= a ^= b;
			sol.pb(mp(a, b));
		}
}

ll mst(int block)
{
	ll res;
	int i, j, n;
	node *p;
	for (i = 0; i <= N; ++i)
		me[i] = INFTY;
	me[1] = 0;
	memset(U, 0, sizeof(U));
	for (res = 0, i = 1; i <= N; ++i) {
		for (n = 0, j = 1; j <= N; ++j)
			if (!U[j] && me[j] < me[n])
				n = j;
		if (n == 0)
			return (ll)N*INFTY;
		res += me[n];
		U[n] = 1;
		for (p = G[n]; p; p = p->lnk)
			if (!U[p->nd] && block != p->id && p->cost < me[p->nd]){
				me[p->nd] = p->cost;
				F[p->nd] = n;
			}
	}
	return res;
}

void brute_solve()
{
	int i, j, n;
	node *p;
	ll bst = mst(-1);
	for (i = 1; i <= N; ++i)
		for (p = G[i]; p != NULL; p = p->lnk)
			if (i < p->nd && (F[p->nd] == i ||
					F[i] == p->nd) && mst(p->id) != bst)
				sol.pb(mp(i, p->nd));
}

void write()
{
	int i;
	FILE *fo = fopen(FOUT, "w");
	fprintf(fo, "%d\n", sol.size());
	sort(sol.begin(), sol.end());
	for (i = 0; i < sol.size(); ++i)
		fprintf(fo, "%d %d\n", sol[i].first, sol[i].second);
	fclose(fo);
}

int main()
{
	read();
	if (N <= 500)
		brute_solve();
	else
		solve();
	write();
	return 0;
}

