#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;

#define NMAX 50005
#define MMAX 100005

struct edge {
    int a, b, c;
} e[MMAX];

int N, M, i, j, k, p1, p2, x, y;
int u[MMAX], eseen[MMAX], nseen[NMAX];
int pi[NMAX], rank[NMAX];
vector<pair<int, int> > adj[NMAX];

int lev[NMAX], sus[NMAX];
pair<int, int> sol[MMAX];

int getset(int x)
{
    return pi[x] == x ? x : pi[x] = getset(pi[x]);
}

void unionset(int x, int y)
{
    x = getset(x), y = getset(y);
    if (rank[x] > rank[y])
        pi[y] = x;
    else
    {
        pi[x] = y;
        if (rank[x] == rank[y])
           ++ rank[y];
    }
}

void read(void)
{
    freopen("vitale.in", "r", stdin);
    freopen("vitale.out", "w", stdout);
    scanf("%d %d", &N, &M);
    for (i = 0; i < M; i ++)
        scanf("%d %d %d", &(e[i].a), &(e[i].b), &(e[i].c));
}

int cmp(struct edge a, struct edge b)
{
    return a.c < b.c ? 1 : 0;
}

void dfs(int x, int clev)
{
    vector<pair<int, int> > :: iterator it;
    sus[x] = lev[x] = clev;
    nseen[x] = p1;

    for (it = adj[x].begin(); it != adj[x].end(); it ++)
        if (eseen[(*it).second] != p1)
        {
            eseen[(*it).second] = p1;
            
            if (nseen[(*it).first] != p1)
                dfs((*it).first, clev + 1);

            if (sus[(*it).first] < sus[x])
               sus[x] = sus[(*it).first];
        }

    for (it = adj[x].begin(); it != adj[x].end(); it ++)
        if (lev[x] + 1 == lev[(*it).first] && sus[(*it).first] == lev[x] + 1)
        {
           u[(*it).second] = 1; //got a critical edge
        }
}

void solve(void)
{
    sort(e, e + M, cmp);
    memset(u, 0, sizeof(u));
    memset(rank, 0, sizeof(rank));
    for (i = 1; i <= N; i ++)
        pi[i] = i;

    memset(eseen, 0xFF, sizeof(eseen));
    memset(nseen, 0xFF, sizeof(nseen));
    
    for (p1 = 0; p1 < M; p1 = p2)
    {
        for (p2 = p1; p2 < M && e[p1].c == e[p2].c; p2 ++);
        // [p1 .. p2 - 1]
        //construire adiacenta
        for (i = p1; i < p2; i ++)
        {
            x = getset(e[i].a), y = getset(e[i].b);
            if (x != y)
            {
                adj[x].push_back(make_pair(y, i));
                adj[y].push_back(make_pair(x, i));
            }
        }
            
        //calculare
        for (i = p1; i < p2; i ++)
        {
            x = getset(e[i].a);
            if (nseen[x] != p1)
                dfs(x, 0);
        }

        //unire, stergere adiacenta
        for (i = p1; i < p2; i ++)
        {
            x = getset(e[i].a), y = getset(e[i].b);
            if (x != y)
               unionset(x, y);
            adj[x].clear(), adj[y].clear();
        }
    }
}

#define MIN(a, b) ((a) < (b) ? (a) : (b))
#define MAX(a, b) ((a) > (b) ? (a) : (b))
void write(void)
{
    int Ans = 0;
    for (i = 0; i < M; i ++)
        if (u[i])
        {
            sol[Ans].first  = MIN(e[i].a, e[i].b);
            sol[Ans].second = MAX(e[i].a, e[i].b);
            ++ Ans;
        }
    sort(sol, sol + Ans);
    printf("%d\n", Ans);
    for (i = 0; i < Ans; i ++)
        printf("%d %d\n", sol[i].first, sol[i].second);
}

void gen(void)
{
    freopen("vitale.in", "w", stdout);
    N = 5, M = 10;
    printf("%d %d\n", N, M);
    for (i = 2; i <= N; i ++)
        printf("%d %d %d\n", i, 1 + (rand() % (i - 1)), 1);
    for (i = 0; i < M - N + 1; i ++)
        printf("%d %d %d\n", (rand() % N) + 1, (rand() % N) + 1, 2);
}

int main(void)
{
//    gen();
//    return 0;
    
    read();
    solve();
    write();
    return 0;
}
