#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define Inside(x, node) (tin[x] >= tin[node] && tout[x] <= tout[node])
#define swap(i, j) i = (i ^ j) ^ (j = i)
#define MAX_N 100333
#define MAX_M 100333

int pi[MAX_N], rank[MAX_N], edge[MAX_M][3], U[MAX_N], N, M;
int tin[MAX_N], tout[MAX_N], *G[MAX_N], dg[MAX_N], solE[MAX_M][2], time, sol;

void df(int node)
{
    int i;
    
    tin[node] = ++time;
    for (i = 0; i < dg[node]; i++)
        if (!tin[G[node][i]]) df(G[node][i]);
    tout[node] = ++time;
}

int cmpSol(const void *ei, const void *ej)
{
    int *i = (int *) ei, *j = (int *) ej;

    if (i[0] < j[0]) return -1;
    if (i[0] > j[0]) return +1;
    if (i[1] < j[1]) return -1;
    else             return +1;
}

int cmpEdge(const void *ei, const void *ej)
{
    int *i = (int *) ei, *j = (int *) ej;

    if (i[2] < j[2]) return -1;
    if (i[2] > j[2]) return +1;
    return 0;
}

int GetDad(int x)
{
    if (pi[x] == x) return x;
    pi[x] = GetDad(pi[x]);
    return pi[x];
}

void Union(int x, int y)
{
    if (rank[x] > rank[y])
        pi[y] = x;
    else
    {
        pi[x] = y;
        if (rank[x] == rank[y]) rank[y]++;
    }
}

void MakeTree()
{
    int i, j, x, y;

    for (i = 0; i < N; i++) pi[i] = i, rank[i] = U[i] = 0;
    for (i = 0; i < M; i++)
    {
        x = edge[i][0], y = edge[i][1];
        x = GetDad(x), y = GetDad(y);
        if (x != y)
        {
           Union(x, y);
           U[i] = 1;
           dg[edge[i][0]]++;
           dg[edge[i][1]]++;
        }
    }

    for (i = 0; i < N; i++)
        G[i] = (int *) malloc(dg[i] * sizeof(int));
    memset(dg, 0, sizeof(dg));

    for (i = 0; i < M; i++)
    if (U[i])
    {
        x = edge[i][0], y = edge[i][1];
        G[x][dg[x]++] = y,
        G[y][dg[y]++] = x;
    }
}

void Solve()
{
    int i, j, k, x, y, p, q, cost, found;

    sol = 0;
    for (i = 0; i < M; i++)
        if (tin[edge[i][0]] > tin[edge[i][1]]) swap(edge[i][0], edge[i][1]);
    for (i = k = 0; i < M; i++)
    if (U[i])
    {
        cost = edge[i][2];
        x = edge[i][0], y = edge[i][1];
        for (; edge[k][2] < cost; k++);
        found = 0;
        for (j = k; j < N && edge[j][2] == cost; j++)
        if (!U[j])
        {
            p = edge[j][0], q = edge[j][1];
            if (Inside(q, y) && !Inside(p, y))
            {
                found = 1;
                break;
            }
        }
        if (!found)
        {
            if (x > y) swap(x, y);
            x++, y++;
            solE[sol][0] = x;
            solE[sol][1] = y;
            sol++;
        }
    }
}

int main()
{
    int i, x, y;
    
    freopen("vitale.in", "r", stdin);
    freopen("vitale.out", "w", stdout);
    scanf("%d %d", &N, &M);
    for (i = 0; i < M; i++)
        scanf("%d %d %d", &edge[i][0], &edge[i][1], &edge[i][2]),
        edge[i][0]--,
        edge[i][1]--;
        
    qsort(edge, M, sizeof(int) * 3, cmpEdge);
    MakeTree();
    
    time = 0;
    df(0);
    Solve();
    
    qsort(solE, sol, sizeof(int) * 2, cmpSol);
    printf("%d\n", sol);
    for (i = 0; i < sol; i++)
        printf("%d %d\n", solE[i][0], solE[i][1]);
    
    return 0;
}
