#include <stdio.h>

#define MAX_N 25
#define MOD 30103
#define FIN "borg.in"
#define FOUT "borg.out"

int N, M, H, K, Res, C[MAX_N][MAX_N], inv[MOD];

int my_pow(int a, int b)
{
    int t;
    
    if (!b) return 1;
    t = my_pow(a, b>>1);
    t = (t*t) % MOD;
    if (b&1) t = (t*a) % MOD;
    return t;
}

int comb(int n, int k)
{
    int i, t = 1;

    if (k > n) return 0;
    for (i = n-k+1; i <= n; i++)
        t = (t*i) % MOD;
    for (i = 2; i <= k; i++)
        t = (t*inv[i]) % MOD;
    return t;
}
    
int main(void)
{
    int i, j, x, y, z, t;

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);
    
    scanf("%d %d %d %d", &N, &M, &H, &K);

    for (i = 1; i < MOD; i++)
        inv[i] = my_pow(i, MOD-2);

    C[0][0] = 1;
    for (i = 1; i < MAX_N; i++)
        for (C[i][0] = j = 1; j <= i; j++)
        {
            C[i][j] = C[i-1][j-1] + C[i-1][j];
            while (C[i][j] >= MOD) C[i][j] -= MOD;
        }

    for (x = 0; x <= N; x++)
        for (y = 0; y <= M; y++)
            for (z = 0; z <= H; z++)
            {
                t = comb((N-x)*(M-y)*(H-z), K);
                t = (t*C[N][x])%MOD;
                t = (t*C[M][y])%MOD;
                t = (t*C[H][z])%MOD;
                
                if ((x+y+z)&1)
                   Res += MOD-t;
                else
                   Res += t;
                while (Res >= MOD) Res -= MOD;
            }

    printf("%d\n", Res);

    return 0;
}
