//vitale

#include <stdio.h>
#include <stdlib.h>

FILE *f = fopen("vitale.in", "r");
FILE *g = fopen("vitale.out", "w");

long const nmax = 100011;
long const mucmax = 100011;
long const inf = 1500000000;

struct muchie { long x, y, cost; };
struct nod {
	nod *suc;
    nod *last;
    long val;
    long cost;
};

long interi, interj;
long n, m, pini, parb, nsol, ti[nmax], tf[nmax];
long comp[nmax], nvc[nmax]; //nr varfuri componenta
long t[nmax], timp; //muchia minima care vine deasupra
long rad, v[nmax];
long long suma;

muchie muini[mucmax], muarb[mucmax], sol[mucmax];
nod *x[nmax], *arb[nmax], *cv[nmax], *cs[nmax];

void citeste();
void adauga(nod **y, long v1, long v2, long cost);
void constrarb(muchie muc[nmax], long p, nod **y);
int fcmp(const void *a, const void *b);
int fcmp2(const void *a, const void *b);
void df(long k);
void concat(long i, long j);
void scrie();
long long kruskal();
long long kruskal2();
void solve();

int main() {
	citeste();
    suma = kruskal();
    solve();
    scrie();
    fclose(f);
    fclose(g);
    return 0;
}

void citeste() {
	long i, vf1, vf2, cos, aux;
    
    fscanf(f, "%d%d", &n, &m);
    for(i=1; i<=m; i++) {
    	fscanf(f, "%d%d%d", &vf1, &vf2, &cos);
        if(vf1 > vf2) {
        	aux = vf1;
            vf1 = vf2;
            vf2 = aux;
        }
        pini++;
        muini[pini].x = vf1;
        muini[pini].y = vf2;
        muini[pini].cost = cos;
    }
    constrarb(muini, pini, x);
}

void adauga(nod **y, long v1, long v2, long cost) {
	nod *c;

    c = new nod;
    c -> suc = 0;
    c -> val = v2;
    c -> cost = cost;

    if(y[v1]==0) y[v1] = c;
    else y[v1] -> last -> suc = c;
    y[v1] -> last = c;
}

void constrarb(muchie muc[nmax], long p, nod **y) {
    long i;

    for(i=1; i<=p; i++) {
    	adauga(y, muc[i].x, muc[i].y, muc[i].cost);
        adauga(y, muc[i].y, muc[i].x, muc[i].cost);
    }
}

int fcmp(const void *a, const void *b) {
	muchie ia = * ((muchie*) a);
    muchie ib = * ((muchie*) b);

    if( ia.cost < ib.cost ) return -1;
    if( ia.cost > ib.cost ) return 1;
    return 0;
}

int fcmp2(const void *a, const void *b) {
	muchie ia = * ((muchie*) a);
    muchie ib = * ((muchie*) b);

    if( ia.x < ib.x ) return -1;
    if( ia.x > ib.x ) return 1;
    if( ia.y < ib.y ) return -1;
    if( ia.y > ib.y ) return 1;
    return 0;
}

void df(long k) {
	nod *c;

    v[k] = 1;
	timp++;
    ti[k] = timp;
    
    c = arb[k];
    while( c!=0 ) {
        if(v[c->val]==0) df( c->val );
    	c = c -> suc;
    }
    timp++;
    tf[k] = timp;
}

void concat(long i, long j) {
	long aux;
    nod *c;
    
    if(nvc[i] <= nvc[j]) {
    	aux = i;
        i = j;
        j = aux;
    }
    
    c = cv[j];
    while( c!=0 ) {
    	comp[ c->val ] = i;
    	c = c -> suc;
    }
    nvc[i] = nvc[i] + nvc[j];

    cs[i] -> suc = cv[j];
    cs[i] = cs[j];
}

void solve() {
	long k;
    long parb1;
    muchie muarb1[mucmax];

    parb1 = parb;
    for(k=1; k<=parb1; k++) muarb1[k] = muarb[k];
	for(k=1; k<=parb1; k++) {
    	interi = muarb1[k].x;
        interj = muarb1[k].y;
        if( suma!=kruskal2() ) {
        	nsol++;
            sol[nsol] = muarb1[k];
        }
    }
}

void scrie() {
	long i;

    fprintf(g, "%d\n", nsol);
    for(i=1; i<=nsol; i++) fprintf(g, "%d%c%d\n", sol[i].x, ' ', sol[i].y);
}

long long kruskal() {
	long i, j, k, pred[nmax];
    long v1, v2;
    nod *c;
    long long s = 0;

    qsort( muini + 1, pini, sizeof(muchie), fcmp);
    for(i=1; i<=n; i++) {
    	comp[i] = i;
        nvc[i] = i;
        
        c = new nod;
        c -> val = i;
        c -> suc = 0;
        cv[i] = c;
        cs[i] = c;
    }
    for(i=1; i<=pini; i++) {
    	v1 = muini[i].x;
        v2 = muini[i].y;
        if( comp[v1]!=comp[v2] ) {
        	concat(comp[v1], comp[v2]);
            parb++;
            muarb[parb].x = v1;
            muarb[parb].y = v2;
            muarb[parb].cost = muini[i].cost;
            s+= muini[i].cost;
        }
    }
    constrarb(muarb, parb, arb);
    qsort( (void*)(muarb + 1), parb, sizeof(muchie), fcmp2);
    return s;
}

long long kruskal2() {
	long i, j, k, pred[nmax];
    long v1, v2;
    nod *c;
    long long s = 0;

    for(i=1; i<=n; i++) {
    	comp[i] = i;
        nvc[i] = i;
        
        c = new nod;
        c -> val = i;
        c -> suc = 0;
        cv[i] = c;
        cs[i] = c;
    }
    parb = 0;
    for(i=1; i<=pini; i++) {
    	v1 = muini[i].x;
        v2 = muini[i].y;
        if( (v1!=interi || v2!=interj) && comp[v1]!=comp[v2] ) {
        	concat(comp[v1], comp[v2]);
            parb++;
            muarb[parb].x = v1;
            muarb[parb].y = v2;
            muarb[parb].cost = muini[i].cost;
            s+= muini[i].cost;
        }
    }
    return s;
}

