# include <stdio.h>

# define _fin  "petrom.in"
# define _fout "petrom.out"

# define maxn 402
# define maxk 302

# define inf  2000000000


int d[maxn], n, k, b[maxk][maxn];
int sol, s[maxk];
int di[maxn], dp[maxn], dt;
int fro[maxk][maxn];


void readf()
{
    int i;
    FILE *fin = fopen(_fin, "r");

    for(fscanf(fin, "%d %d", &n, &k), i=1; i<=n; i++)
	fscanf(fin, "%d", d+i), dt += d[i];

    fclose(fin);
}

void writef()
{
    FILE *fout = fopen(_fout, "w");
    int i;

    fprintf(fout, "%d\n", sol);

    for(i=1; i<=k; i++)
	fprintf(fout, "%d\n", s[i]);

    fclose(fout);
}

int interval(int bg, int end, int mid)
{
    // suma pe intervalul bg...end, cu benzinarie plasata pe mid
    int r1=0, r2=0;
//    if (bg < mid)
	r1 =  d[mid] * (mid-bg) - ( di[mid] - di[bg] );
//    if (mid < end)
	r2 = dp[mid] - dp[end] - d[mid] * (end-mid);

    return (r1+r2);
}

void solve()
{
    int i, j, bn, bz, aux;

    dp[1] = dt-d[1];

    for(i=2; i<=n; i++)
	di[i] = di[i-1] + d[i-1],
	dp[i] = dt - di[i] - d[i];

    for(i=1; i<=n; i++)
    {
	b[1][i] = interval(1, n, i);  // (i-1)*d[i] - di[i] - (n-i)*d[i] + dp[i];
    }

    for(i=2; i<=k; i++) // mai plasam o benzinarie
	for(j=i; j<=n; j++)
	{
	    // alegem punctul de separatie dintre ultima plasata si
	    // aceasta noua
	    b[i][j] = inf;

	    // unde a fost ultima plasata
	    for(bz=i-1; bz<j; bz++)
		// unde facem punctul de separatie
		for(bn=bz+1; bn <= j; bn++)
		{
		    aux = b[i-1][bz] - ( dp[bn-1] - (n-bn+1) * d[bz] );
		    aux += interval( bn, n, j );

		    if ( aux < b[i][j] )
		    {
			b[i][j] = aux;
			fro[i][j] = bz;
		    }
		}
	}

    for(i=1; i<=n; i++)
	if ( b[k][i] && b[k][i] < sol ) sol = b[k][i];

    // gasesc minim / construiesc solutia
    int pmin=-1;

    for(i=k; i<=n; i++)
	if ( pmin == -1 || b[k][i] < b[k][pmin] )
	     pmin = i;

    s[k] = pmin;
    sol = b[k][pmin];

    for(j=k-1; j>=1; j--)
	s[j] = fro[j+1][pmin],
	pmin = fro[j+1][pmin];

}

int main()
{
    readf();
    solve();
    writef();

    return 0;
}