#include <stdio.h>

#define INF (1 << 30)
#define MAXN 405
#define MAX_K 305
#define abs(x) ((x) < 0 ? (-(x)) : (x))

int N, K, sum[MAXN][MAXN], A[MAXN][MAXN], B[MAXN][MAXN];
int D[MAXN][MAXN], R[MAX_K][MAXN], T[MAX_K][MAXN];
int dist[MAXN];
int cmin[MAX_K][MAXN];

void preproc(void)
{
	int i, j, t;

	for(i = 1; i <= N; i++)
	 for(j = 1; j <= N; j++)
	 	sum[i][j] = abs(dist[i]-dist[j]);

	for(i = N-1; i >= 1; i--)
	 for(j = i+1; j <= N; j++)
		D[i][j] = D[i+1][j]+sum[i][j];

    for(i = 2; i <= N; i++)
	 for(j = i-1; j >= 1; j--)
	 	D[i][j] = D[i-1][j]+sum[i][j];

    for(i = 1; i <= N; i++)
	 for(j = i; j <= N; j++)
     {
	 	A[i][j] = INF;
	 	for(t = i; t <= j; t++)
		 if(D[i][t]+D[j][t] < A[i][j])
		 	A[i][j] = D[i][t]+D[j][t], B[i][j] = t;
     }
}

void solve(void)
{
	int n, k, p;

	for(n = 1; n <= N; n++)
		cmin[1][n] = A[1][n], R[1][n] = B[1][n];

    for(k = 2; k <= K; k++)
	 for(n = k; n <= N; n++)
	 {
	 	cmin[k][n] = INF;
		for(p = n-1; p >= k-1; p--)
		 if(cmin[k][n] > cmin[k-1][p]+A[p+1][n])
         {
		 	cmin[k][n] = cmin[k-1][p]+A[p+1][n];
 			R[k][n] = B[p+1][n], T[k][n] = p;
         }
     }
}

void rec(int k, int n)
{
	if(k == 1)
		printf("%d\n", R[k][n]);
    else
	{
		rec(k-1, T[k][n]);
		printf("%d\n", R[k][n]);
    }
}

void read_data(void)
{
	int i;
	scanf("%d %d\n", &N, &K);
	for(i = 1; i <= N; i++)
		scanf("%d\n", &dist[i]);
}

void write_data(void)
{
	printf("%d\n", cmin[K][N]);
	rec(K, N);
}

int main(void)
{
	freopen("petrom.in", "rt", stdin);
	freopen("petrom.out", "wt", stdout);

	read_data();
	preproc();
	solve();
	write_data();

	return 0;
}




