#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define Nmax 1001
int n, m, a[Nmax][Nmax], no[Nmax][Nmax];
FILE *fi, *fo;

void read_data()
{
	int i, j;
	fscanf(fi, "%d %d", &n, &m);
	for (i = 1; i <= n; ++i)
		for (j = 1; j <= m; ++j)
			fscanf(fi, "%d", &a[i][j]);
}

void step1()
{
	int i, j, c, type;
	for (i = 1; i <= n; ++i)
		no[i][1] = 1, no[i][2] = 2;
	for (i = 1; i <= n; ++i)
	{
		c = 1;
		if (a[i][2] > a[i][1])
			type = 1;
		else
			if (a[i][2] < a[i][1])
				type = 2;
			else
				type = 0;
		for (j = 3; j <= m; ++j)
			if (a[i][j] > a[i][j - 1])
			{
				if (!type || type == 1)
					no[i][j] = no[i][j - 1] + 1;
				else
					no[i][j] = j - c + 1, c = j - 1;
				type = 1;
			}
			else
				if (a[i][j] < a[i][j - 1])
				{
					if (!type || type == 2)
						no[i][j] = no[i][j - 1] + 1;
					else
						no[i][j] = j - c + 1, c = j - 1;
					type = 2;
				}
				else
					no[i][j] = no[i][j - 1] + 1;
	}
}

void step2_brute()
{
	int i, j, k, min, x1, x2, y1, y2, sol;
	sol = 0;
	for (i = 1; i <= n; ++i)
		for (j = 1; j <= m; ++j)
		{
			min = 0x3f3f3f3f;
			for (k = i; k <= n; ++k)
			{
				if (no[k][j] < min)
					min = no[k][j];
				if (min * (k - i + 1) > sol)
					sol = min * (k - i + 1), x1 = i, x2 = k, y1 = j - min + 1, y2 = j;
			}
		}
	fprintf(fo, "%d %d %d %d\n",x1, y1, x2, y2);
}

void step2()
{
	int i, j, k, first, last, dq[Nmax], p[Nmax], x1, x2, y1, y2, sol;
	sol = 0;
	for (j = 1; j <= m; ++j)
	{
		memset(dq, 0, sizeof(dq));
		first = last = 1;
		p[first] = 1;
		dq[first] = no[1][j];
		if (no[1][j] > sol)
		{
			sol = no[1][j];
			x1 = 1, x2 = 1;
			y1 = j - no[1][j] + 1, y2 = j;
		}
		for (i = 2; i <= n; ++i)
		{
			k = i;
			while (last >= first && no[i][j] <= dq[last])
			{
				if (dq[last] * (i - p[last]) > sol) 
				{
					sol = dq[last] * (i - p[last]);
					x1 = p[last];
					y1 = j - dq[last] + 1;
					x2 = i - 1;
					y2 = j;
				}
				if (no[i][j] * (i - p[last] + 1) > sol)
				{
					sol = no[i][j] * (i - p[last] + 1);
					x1 = p[last];
					y1 = j - dq[last] + 1;
					x2 = i;
					y2 = j;
				}
				if (p[last] < k)
					k = p[last];
				--last;
			}
			dq[++last] = no[i][j];
			p[last] = k;
		}
		for (; first <= last; ++first)
			if (dq[first] * (n - p[first] + 1) > sol)
			{
				sol = dq[first] * (n - p[first] + 1);
				x1 = p[first];
				y1 = j - dq[first] + 1;
				x2 = n;
				y2 = j;
			}
	}
	fprintf(fo, "%d %d %d %d\n", x1, y1, x2, y2);
}

void solve()
{
	step1();
	if (n * m <= 160000)
		step2_brute();
	else
		step2();
}

int main()
{
	fi = fopen("matrice.in","r");
	fo = fopen("matrice.out","w");
	read_data();
	solve();
	fclose(fi);
	fclose(fo);
	return 0;
}
