#include <stdio.h>
#include <string.h>

#define MAX_CUV_NR 10002
#define MAX_L 2002

class Cache
{
private:
	class Node
    {
    public:
    	int key;
        int data;
        Node *left, *right;
    };
    Node *m_root;

    void _insert( Node *& root, int key, int data )
    {
    	if( !root )
        {
        	root = new Node();
            root->key = key;
            root->data = data;
            return;
        }
        if( key > root->key ) _insert( root->right, key, data );
        _insert( root->left, key, data );
   }

   int _get( Node *root, int key, int &data )
   {
    	if( !root ) return 0;
        if( key == root->key )
        {
        	data = root->data;
        	return 1;
        }
        if( key > root->key ) return _get( root->right, key, data );
        return _get( root->left, key, data );
   }
    
public:
	Cache():m_root(NULL) {}

    void insert( int key, int data )
	{
    	_insert( m_root, key, data );
    }

    int get( int key, int &data )
    {
    	return _get( m_root, key, data );
    }
};

char cuv[MAX_CUV_NR][MAX_L];
int l[MAX_CUV_NR];
int n, m;
Cache cache[MAX_CUV_NR];

int get_k_naiv( int c1, int c2, int min )
{
    for( int i=0; i<min; i++ )
    	if( cuv[c1][i] != cuv[c2][i] ) return i;
    return min;
}

int get_k( int c1, int c2, int min )
{
	if( c1 == c2 ) return l[c1];
    if( c1 > c2 )
    {
    	int aux = c1;
        c1 = c2;
        c2 = aux;
    }
    int r;
    if( cache[c1].get(c2,r) )
    {
    	return r;
    }
    else
    {
		r = get_k_naiv( c1, c2, min );
        cache[c1].insert( c2, r );
        return r;
    }
}

inline int get_min( int a, int b )
{
	if( a>b ) return b;
    return a;
}

int main()
{
	int i,j;
	FILE *f = fopen( "ratina.in", "r" );
    FILE *fout = fopen( "ratina.out", "w" );
    if( !f ) return 1;

   	fscanf( f, "%d %d", &n, &m );
    fgets( cuv[0], MAX_L-1, f );
    for( i=0; i<n; i++ )
    {
    	fgets( cuv[i], MAX_L-1, f );
        l[i] = strlen( cuv[i] ) - 1;
        cuv[i][ l[i] ] = 0;
    }

    int q[15], t, minl, mini, k;
    for( i=0; i<m; i++ )
    {
		fscanf( f, "%d", &t );
        fscanf( f, "%d", &q[0] );
        
        minl = l[q[0]-1];
        mini = q[0]-1;
        k = 2005;
        
        for( j=1; j<t; j++ )
    	{
        	fscanf( f, "%d", &q[j] );
            if( minl > l[q[j]-1] )
            {
            	minl = l[q[j]-1];
                mini = q[j]-1;
            }
        }
   	    for( j=0; j<t; j++ )
        	if( (q[j]-1) != mini )
	        {
                k = get_min( k, get_k(mini, q[j]-1, minl) );
    	    }
        if( k == 2005 ) k = l[mini];
        fprintf( fout, "%d\n", k );
    }
    fclose(fout);
    fclose(f);
	return 0;
}

