#include <stdio.h>
#include <string.h>

#define FIN "petrom.in"
#define FOUT "petrom.out"

#define MAX_N 410
#define MAX_K 310

#define INFTY 60001

int N, K;
int X[MAX_N], cost[MAX_N][MAX_N], T[MAX_N][MAX_K], F[MAX_N][MAX_K];

void read()
{
	int i;
	FILE *fi = fopen(FIN, "r");
	fscanf(fi, "%d %d", &N, &K);
	for (i = 1; i <= N; ++i)
		fscanf(fi, "%d", X+i);
	X[0] = -INFTY, X[N+1] = +INFTY;
	fclose(fi);
}

void rebuild(FILE *f, int i, int j)
{
	if (i > 0) {
		rebuild(f, F[i][j], j-1);
		if (j <= K)
			fprintf(f, "%d\n", i);
	}
}

void solve()
{
	int i, j, k, cur, t;
	for (cost[0][1] = 0, i = 2; i <= N; ++i)
		cost[0][i] = cost[0][i-1]+(i-1)*(X[i]-X[i-1]);
	for (cost[N][N+1] = 0, i = N-1; i > 0; --i)
		cost[i][N+1] = cost[i+1][N+1]+(N-i)*(X[i+1]-X[i]);
	for (i = 1; i <= N; ++i) {
		for (cost[i][i+1] = cur = 0, k = i, j = i+1; j <= N; ++j) {
			while (k+1 < j && X[k+1]-X[i] < X[j]-X[k+1]) {
				cur += (X[k+1]-X[i])-(X[j]-X[k+1]);
				k++;
			}
			cost[i][j] = cur;
			if (j < N)
				cur += (j-k)*(X[j+1]-X[j]);
		}
	}
	memset(T, 0x3f3f3f3f, sizeof(T));
	T[0][0] = 0;
	for (i = 0; i <= N; ++i)
		for (j = 0; j <= K; ++j)
			for (t = T[i][j], k = i+1; k <= N+1; ++k)
				if (t+cost[i][k] < T[k][j+1]) {
					T[k][j+1] = t+cost[i][k];
					F[k][j+1] = i;
				}
}

void write()
{
	FILE *fo = fopen(FOUT, "w");
	fprintf(fo, "%d\n", T[N+1][K+1]);
	rebuild(fo, N+1, K+1);
	fclose(fo);
}

int main()
{
	read();
	solve();
	write();
	return 0;
}
