#include <stdio.h>
#include <string.h>

#define FIN "ratina.in"
#define FOUT "ratina.out"

#define MAX_N 10010
#define MAX_L 2048

int N, M, maxlen, L[MAX_N], A[1<<15], Eq[MAX_N];
char W[MAX_N][MAX_L];

void read()
{
	int i;
	scanf("%d %d\n", &N, &M);
	for (i = 1; i <= N; ++i)
		fgets(W[i], MAX_L, stdin);
}

#define lf (p<<1)
#define rt (lf+1)
#define md ((l+r)>>1)

inline int min(int x, int y)
{
	return x < y ? x : y;
}

void build(int p, int l, int r)
{
	if (l == r)
		A[p] = Eq[l];
	else {
		build(lf, l, md);
		build(rt, md+1, r);
		A[p] = min(A[lf], A[rt]);
	}
}

int query(int p, int l, int r, int s, int d)
{
	if (s <= l && r <= d)
		return A[p];
	else {
		int res = MAX_L, q;
		if (s <= md) {
			q = query(lf, l, md, s, d);
			if (q < res)
				res = q;
		}
		if (d > md) {
			q = query(rt, md+1, r, s, d);
			if (q < res)
				res = q;
		}
		return res;
	}
}

void solve()
{
	int c, i, j, t, x, min_pos, max_pos;
	int P[MAX_N], R[MAX_N], cnt[MAX_N];
	for (maxlen = 0, i = 1; i <= N; ++i) {
		L[i] = strlen(W[i])-1;
		if (L[i] > maxlen)
			maxlen = L[i];
	}
	for (i = 1; i <= N; ++i)
		for (j = L[i]; j < maxlen; ++j)
			W[i][j] = 'a'-1;
	for (i = 1; i <= N; ++i)
		P[i] = i;
	for (c = maxlen-1; c >= 0; --c) {
		memset(&cnt['a'-1], 0, 30*sizeof(int));
		for (i = 1; i <= N; ++i)
			cnt[ W[i][c] ]++;
		for (i = 'a'; i <= 'z'; ++i)
			cnt[i] += cnt[i-1];
		for (i = N; i > 0; --i)
			R[ cnt[ W[ P[i] ][c] ]-- ] = P[i];
		memcpy(P, R, sizeof(P));
	}
	for (i = 1; i <= N; ++i)
		R[ P[i] ] = i;
	for (i = 1; i < N; ++i) {
		for (j = 0; j < maxlen && W[ P[i] ][j] == W[ P[i+1] ][j]; ++j);
		Eq[i] = j;
	}
	if (N > 1)
		build(1, 1, N-1);
	for (i = 0; i < M; ++i) {
		for (scanf("%d", &t), min_pos = N, max_pos = 1; t--; ) {
			scanf("%d", &x);
			if (min_pos > R[x])
				min_pos = R[x];
			if (max_pos < R[x])
				max_pos = R[x];
		}
		if (min_pos == max_pos) {
			printf("%d\n", L[ P[min_pos] ]);
		}
		else {
			printf("%d\n", query(1, 1, N-1, min_pos, max_pos-1));
		}
	}
}

int main()
{
	freopen(FIN, "r", stdin);
	freopen(FOUT, "w", stdout);

	read();
	solve();
	return 0;
}
