#include <stdio.h>
#define swap(i, j) i = (i ^ j) ^ (j = i)
#define MAX_N 1024

int mat[MAX_N][MAX_N], D[MAX_N][MAX_N], N, M;
int bits[MAX_N], st[MAX_N], top;
int left[MAX_N], right[MAX_N], V[MAX_N], area, hmax, s0, s1;

void Compute(int V[], int D[], int N)
{
    int i;

    for (i = 1; i < N; i++)
        if (V[i] > V[i-1]) bits[i] = 1;
        else bits[i] = 0;
    D[0] = D[1] = 0;
    st[1] = 1;
    for (i = 2; i < N; i++)
        if (bits[i] == bits[i-1])
            D[i] = D[i-1],
            st[i] = st[i-1];
        else
            D[i] = st[i-1] - 1,
            st[i] = i;
}

void MakeLeft(int V[], int D[])
{
    int i;

    top = 0;
    for (i = 0; i < N; i++)
    {
        D[i] = i;
        for (; top && V[st[top-1]] >= V[i]; top--)
            D[i] = D[st[top-1]];
        if (!top) D[i] = 0;
        st[top++] = i;
    }
}

void Swap(int V[])
{
    int i;

    for (i = 0; 2 * i < N; i++)
        swap(V[i], V[N-i-1]);
}

void Solve(int pos)
{
    int i, t;

    for (i = 0; i < N; i++)
        V[i] = pos - D[i][pos] + 1;
    MakeLeft(V, left);
    Swap(V);
    MakeLeft(V, right);
    Swap(right);
    Swap(V);
    for (i = 0; i < N; i++)
        right[i] = N - 1 - right[i];

    area = 0;
    for (i = 0; i < N; i++)
    {
        t = V[i] * (right[i] - left[i] + 1);
        if (t > area)
            area = t,
            hmax = V[i],
            s0 = left[i], s1 = right[i];
    }
}

int main()
{
    int bst, l1, l2, c1, c2, i, j;
    
    freopen("matrice.in", "r", stdin);
    freopen("matrice.out", "w", stdout);
    scanf("%d %d", &N, &M);
    for (i = 0; i < N; i++)
    for (j = 0; j < M; j++)
        scanf("%d", &mat[i][j]);

    for (i = 0; i < N; i++)
        Compute(mat[i], D[i], M);

    bst = 0;
    for (i = 0; i < M; i++)
    {
        Solve(i);
        if (area > bst)
            bst = area,
            c2 = i, c1 = i - hmax + 1,
            l1 = s0, l2 = s1;
    }
    printf("%d %d %d %d\n", l1+1, c1+1, l2+1, c2+1);

    return 0;
}
