#include <stdio.h>
#define max(i, j) ((i) > (j) ? (i) : (j))
#define INF 0x3f3f3f3f
#define FAIL 23
#define MAX_N 512

int cost[MAX_N][MAX_N], V[MAX_N], S[MAX_N], N, K;
int D[MAX_N][MAX_N], T[MAX_N][MAX_N], last;

int Find(int x, int y)
{
    int delta, i, key;

    for (delta = 1; delta <= y - x; delta <<= 1);
    key = (V[x] + V[y]) >> 1;
    for (i = x; delta; delta >>= 1)
        if (i + delta <= y && V[i+delta] <= key) i += delta;
    return i;
}

void Build()
{
    int i, j, l;

    S[0] = V[0];
    for (i = 1; i < N; i++) S[i] = S[i-1] + V[i];
    for (i = 0; i < N; i++)
    for (j = i+1; j < N; j++)
    {
        l = Find(i, j);
        cost[i][j] = S[l] - S[i] - V[i] * (l - i) +
                     V[j] * (j - l - 1) - (S[j-1] - S[l]);
    }
}

int Solve()
{
    int i, j, k, t, bi, bst;

    D[0][1] = 0;
    for (i = 1; i < N; i++)
        D[i][1] = D[i-1][1] + (V[i] - V[i-1]) * i;
    for (j = 2; j <= K; j++)
        for (k = i = 0; i < N; i++)
        {
            bst = D[k][j-1] + cost[k][i];
            for (k++; k < i && D[k][j-1] + cost[k][i] <= bst; k++)
                bst = D[k][j-1] + cost[k][i];
            k--;

            for (bi = -1, t = 0; t < FAIL && k + t < i; t++)
                if (D[k+t][j-1] + cost[k+t][i] < bst)
                    bi = k + t,
                    bst = D[bi][j-1] + cost[bi][i];
            if (bi == -1) bi = k;
            
            D[i][j] = bst, T[i][j] = bi;
        }

    bst = D[N-1][K], j = N-1;
    k = 0;
    for (i = N-2; i >= 0; i--)
    {
        k += (V[i+1] - V[i]) * (N - 1 - i);
        if (k + D[i][K] < bst)
           bst = k + D[i][K],
           j = i;
    }
    last = j;
    return bst;
}

void Rebuild(int i, int k)
{
    if (k != 1) Rebuild(T[i][k], k-1);
    printf("%d\n", i+1);
}

int main()
{
    int i;
    
    freopen("petrom.in", "r", stdin);
    freopen("petrom.out", "w", stdout);
    scanf("%d %d", &N, &K);
    for (i = 0; i < N; i++)
        scanf("%d", &V[i]);
    Build();
    printf("%d\n", Solve());
    Rebuild(last, K);
    
    return 0;
}
