#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define swap(i, j) (i = (i ^ j) ^ (j = i))
#define min(i, j) ((i) < (j) ? (i) : (j))
#define INF 0x3f3f3f3f
#define MAX_N 10333
#define SIZE 2048

char W[MAX_N][SIZE];
int D[16][MAX_N], ind[MAX_N], pos[MAX_N], V[MAX_N], N, M, K;

int cmp(const void *ei, const void *ej)
{
    int i = *(int *) ei, j = *(int *) ej;

    return strcmp(W[i], W[j]);
}

void Compute()
{
    int pow, i, j, t, L1, L2, s1, s2;

    s1 = ind[0];
    L1 = strlen(W[s1]);
    for (i = 0; i < N-1; i++)
    {
        s2 = ind[i+1];
        L2 = strlen(W[s2]);
        for (j = 0; j < L1 && j < L2 && W[s1][j] == W[s2][j]; j++);
        D[0][i] = j;
        L1 = L2, s1 = s2;
    }
    for (j = 1, pow = 4; pow <= N; pow <<= 1, j++)
        for (i = 0; i + pow - 1 < N; i++)
        {
            t = min(D[j-1][i], D[j-1][i+pow/2]);
            t = min(t, D[0][i+pow/2-1]);
            D[j][i] = t;
        }
}

int Solve(int x, int y)
{
    int pow, j;

    if (x == y) return strlen(W[ind[x]]);
    for (pow = 2, j = 0; pow <= y - x + 1; pow <<= 1, j++);
    pow >>= 1, j--;
    if (pow == y - x + 1) return D[j][x];
    return min(D[j][x], D[j][y + 1 - pow]);
}

int main()
{
    int sol, i, j, l;
    
    freopen("ratina.in", "r", stdin);
    freopen("ratina.out", "w", stdout);
    scanf("%d %d\n", &N, &M);
    for (i = 0; i < N; i++)
        scanf("%s\n", W[i]), ind[i] = i;

    qsort(ind, N, sizeof(int), cmp);
    for (i = 0; i < N; i++)
        pos[ind[i]] = i;
        
    Compute();
    for (i = 0; i < M; i++)
    {
        scanf("%d", &K);
        for (j = 0; j < K; j++)
            scanf("%d", &V[j]),
            V[j] = pos[V[j]-1];
        for (j = 0; j < K; j++)
        for (l = j+1; l < K; l++)
            if (V[j] > V[l]) swap(V[j], V[l]);

        sol = INF;
        for (j = 1; j < K; j++)
            l = Solve(V[j-1], V[j]),
            sol = min(sol, l);
        printf("%d\n", sol);
    }

    return 0;
}
