#include <stdio.h>
#include <string.h>

#define FIN "petrom.in"
#define FOUT "petrom.out"

#define MAX_L 2
#define MAX_K 301
#define MAX_N 400
#define MAX_D 30001
#define INF 0x3f3f3f3f

int a, b, st[MAX_K], D[MAX_N];
int K, N, CL[MAX_D], L[MAX_D], B[MAX_L][MAX_N], F[MAX_K][MAX_N];

void solve(void)
{
    int i, j, k, t, tmp, pos, best, m, dist;

    memset(B, 0, sizeof(B));
    a = 0, b = 1;
    for (i = 0; i < N; i++)
    {
        F[0][i] = -1;
        B[0][i] = (CL[D[i]] * D[i]) - L[D[i]];
    }
    for (i = 1; i < K; i++, a = 1 - a, b = 1 - b)
        for (j = N - (K - i), t = i - 1; j >= t; j--)
        {
            for (k = j - 1, best = INF, pos = -2, tmp = i - 2 > 0 ? i - 2 : 0; k >= tmp; k--)
            {
                m = (D[j] + D[k]) >> 1;
                dist = L[m] - L[D[k]] - (CL[m] - CL[D[k]]) * D[k];
                dist += (CL[D[j]] - CL[m]) * D[j] - (L[D[j]] - L[m]);
                dist += B[a][k];
                if (dist < best)
                   best = dist, pos = k;
            }
            B[b][j] = best;
            F[i][j] = pos;
        }
    for (i = K - 1; i < N; i++)
        for (j = i + 1; j < N; j++)
            B[a][i] += D[j] - D[i];
}

void write(void)
{
    int i, stk, pos, best;

    for (i = K - 1, best = INF; i < N; i++)
        if (B[a][i] < best)
           best = B[a][i], pos = i;
    printf("%d\n", best);
    for (stk = 0, i = K - 1; i >= 0; pos = F[i--][pos])
        st[stk++] = pos;
    for (; stk-- > 0; printf("%d\n", st[stk] + 1)) ;
}

int main(void)
{
    int i;

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    memset(L, 0, sizeof(L));
    memset(CL, 0, sizeof(CL));
    scanf("%d %d", &N, &K);
    for (i = 0; i < N; i++)
    {
        scanf("%d", D + i);
        CL[D[i]]++, L[D[i]] += D[i];
    }
    for (i = 1; i < MAX_D; i++)
    {
        L[i] += L[i - 1];
        CL[i] += CL[i - 1];
    }

    solve();
    write();

    return 0;
}
