#include <stdio.h>
#include <stdlib.h>
#include <string.h>

FILE *f = fopen("petrom.in", "r");
FILE *g = fopen("petrom.out", "w");

long const nmax = 410; //410
long const inf = 1000000000;


long n, benz;
long x[nmax];
long suma[nmax], sumaf[nmax];
long cost[nmax][nmax], poz[nmax][nmax];
long t[nmax][nmax], pred[nmax][nmax];
long sol[nmax], nsol;

void citeste(); //ok
void calccost(); //ok
void calct();
void recon(long i, long k);
long dis(long i, long j);//ok
void solve();
void scrie();

int main() {
	long k;

	citeste();
	calccost();
	calct();
	recon(n, benz);
	scrie();
	fclose(f);
	fclose(g);
	return 0;
}

void citeste() {
	long i;

	suma[0] = 0;
	fscanf(f, "%d%d", &n, &benz);
	for(i=1; i<=n; i++) {
		fscanf(f, "%d", &(x[i]));
		suma[i] = suma[i-1] + x[i];
	}
	sumaf[n] = 0;
	for(i=n-1; i>=1; i--) sumaf[i] = sumaf[i+1] + x[n] - x[i];
}


void calccost() {
	long i, j, k, lim1, lim2;
	long dist, minim, jmin;

	for(i=1; i<=n; i++) {
		cost[i][i] = 0;
		poz[i][i] = i;
		if( i < n ) {
			cost[i][i+1] = x[i+1] - x[i];
			poz[i][i+1] = i + 1;
		}
		if(i<=n-2) {
			cost[i][i+2] = x[i+2] - x[i];
			poz[i][i+2] = i + 1;
		}
	}
	for(k=3; k<=n-1; k++) {
		for(i=1; i<=n-k; i++) {
			lim1 = poz[i][ (i + k + i) / 2 ];
			lim2 = poz[ ( i + k + i ) / 2  + 1][i+k];
			minim = inf;
			for(j=lim1; j<=lim2; j++) {
				dist = dis(j, i) + dis(j, i + k);
				if(minim > dist) {
					minim =  dist;
					jmin = j;
				}
			}
			cost[i][i + k] = minim;
			poz[i][i + k] = jmin;
		}
	}
}

long dis(long i, long j) {
	long dist;

	if(i==j) return 0;
	if( i < j) dist = suma[j] - suma[i] - ( (j-i) * x[i]);
	else dist = sumaf[j] - sumaf[i] - ( (i-j) * (x[n] - x[i]));
	return dist;
}


void calct() {
	long i, j, k, imin, jmin;
	long minim, exp;

	for(i=1; i<=n; i++) {
		t[i][1] = cost[1][i];
		pred[i][1] = -1;
	}

	for(k=2; k<=benz; k++) {
		for(i=k; i<=n; i++) {
			minim = inf;
			for(j=i-1; j>=k-1; j--) {
				exp = t[j][k-1] + cost[j+1][i];
				if(exp < minim) {
					minim = exp;
					jmin = j;
				}
			}
			t[i][k] = minim;
			pred[i][k] = jmin;
		}
	}
}

void recon(long i, long k) {
	long ti;

	nsol++;
	ti = pred[i][k];
	if(ti ==-1) sol[nsol] = poz[1][i];
	else {
		sol[nsol] = poz[ti + 1][i];
		recon(ti, k-1);
	}
}


void scrie() {
	long i;

	fprintf(g, "%d\n", t[n][benz]);
	for(i=nsol; i>=1; i--) fprintf(g, "%d\n", sol[i]);
}
